#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 25 "policy_parse.y"
#include <sys/types.h>
#include <stdint.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>

#include <sepol/policydb.h>
#include <sepol/services.h>
#include <sepol/conditional.h>
#include <sepol/flask.h>
#include <sepol/hierarchy.h>
#include "queue.h"
#include "checkpolicy.h"

/* 
 * We need the following so we have a valid error return code in yacc
 * when we have a parse error for a conditional rule.  We can't check 
 * for NULL (ie 0) because that is a potentially valid return.
 */
static cond_av_list_t *conditional_unused_error_code;
#define COND_ERR (cond_av_list_t *)&conditional_unused_error_code

#define TRUE 1
#define FALSE 0

policydb_t *policydbp;
queue_t id_queue = 0;
unsigned int pass;
char *curfile = 0;
unsigned int curline; 

extern unsigned long policydb_lineno;

extern char yytext[];
extern int yylex(void);
extern int yywarn(char *msg);
extern int yyerror(char *msg);

static char errormsg[255];

static int insert_separator(int push);
static int insert_id(char *id,int push);
static int id_has_dot(char *id);
static int define_class(void);
static int define_initial_sid(void);
static int define_common_perms(void);
static int define_av_perms(int inherits);
static int define_sens(void);
static int define_dominance(void);
static int define_category(void);
static int define_level(void);
static int define_attrib(void);
static int define_typealias(void);
static int define_typeattribute(void);
static int define_type(int alias);
static int define_compute_type(int which);
static int define_te_avtab(int which);
static int define_role_types(void);
static role_datum_t *merge_roles_dom(role_datum_t *r1,role_datum_t *r2);
static role_datum_t *define_role_dom(role_datum_t *r);
static int define_role_trans(void);
static int define_range_trans(void);
static int define_role_allow(void);
static int define_constraint(constraint_expr_t *expr);
static int define_validatetrans(constraint_expr_t *expr);
static int define_bool();
static int define_conditional(cond_expr_t *expr,cond_av_list_t *t_list, cond_av_list_t *f_list );
static cond_expr_t *define_cond_expr(uint32_t expr_type, void *arg1, void* arg2);
static cond_av_list_t *define_cond_pol_list(cond_av_list_t *avlist, cond_av_list_t *stmt);
static cond_av_list_t *define_cond_compute_type(int which);
static cond_av_list_t *define_cond_te_avtab(int which);
static cond_av_list_t *cond_list_append(cond_av_list_t *sl, avtab_key_t *key, avtab_datum_t *datum);
static void cond_reduce_insert_list(cond_av_list_t *new, cond_av_list_t **active, cond_av_list_t **inactive, int state ); 
static uintptr_t define_cexpr(uint32_t expr_type, uintptr_t arg1, uintptr_t arg2);
static int define_user(void);
static int parse_security_context(context_struct_t *c);
static int define_initial_sid_context(void);
static int define_fs_use(int behavior);
static int define_genfs_context(int has_type);
static int define_fs_context(unsigned int major, unsigned int minor);
static int define_port_context(unsigned int low, unsigned int high);
static int define_netif_context(void);
static int define_ipv4_node_context(unsigned int addr, unsigned int mask);
static int define_ipv6_node_context(void);
#line 112 "policy_parse.y"
typedef union {
	unsigned int val;
	uintptr_t valptr;
	void *ptr;
} YYSTYPE;
#line 109 "y.tab.c"
#define YYERRCODE 256
#define PATH 257
#define CLONE 258
#define COMMON 259
#define CLASS 260
#define CONSTRAIN 261
#define VALIDATETRANS 262
#define INHERITS 263
#define SID 264
#define ROLE 265
#define ROLES 266
#define TYPEALIAS 267
#define TYPEATTRIBUTE 268
#define TYPE 269
#define TYPES 270
#define ALIAS 271
#define ATTRIBUTE 272
#define BOOL 273
#define IF 274
#define ELSE 275
#define TYPE_TRANSITION 276
#define TYPE_MEMBER 277
#define TYPE_CHANGE 278
#define ROLE_TRANSITION 279
#define RANGE_TRANSITION 280
#define SENSITIVITY 281
#define DOMINANCE 282
#define DOM 283
#define DOMBY 284
#define INCOMP 285
#define CATEGORY 286
#define LEVEL 287
#define RANGE 288
#define MLSCONSTRAIN 289
#define MLSVALIDATETRANS 290
#define USER 291
#define NEVERALLOW 292
#define ALLOW 293
#define AUDITALLOW 294
#define AUDITDENY 295
#define DONTAUDIT 296
#define SOURCE 297
#define TARGET 298
#define SAMEUSER 299
#define FSCON 300
#define PORTCON 301
#define NETIFCON 302
#define NODECON 303
#define FSUSEXATTR 304
#define FSUSETASK 305
#define FSUSETRANS 306
#define GENFSCON 307
#define U1 308
#define U2 309
#define U3 310
#define R1 311
#define R2 312
#define R3 313
#define T1 314
#define T2 315
#define T3 316
#define L1 317
#define L2 318
#define H1 319
#define H2 320
#define NOT 321
#define AND 322
#define OR 323
#define XOR 324
#define CTRUE 325
#define CFALSE 326
#define IDENTIFIER 327
#define USER_IDENTIFIER 328
#define NUMBER 329
#define EQUALS 330
#define NOTEQUAL 331
#define IPV6_ADDR 332
const short yylhs[] = {                                        -1,
   23,   28,    0,   19,   19,   33,   20,   20,   35,   21,
   36,   36,   38,   38,   39,   37,   37,   41,   41,   41,
   22,   22,   42,   43,   43,   48,   48,   49,   44,   44,
   45,   45,   51,   51,   52,   52,   46,   46,   53,   53,
   47,   47,   55,   55,   56,   57,   24,   24,   58,   58,
   58,   60,   60,   60,   60,   59,   59,   59,   59,   59,
   59,   59,   59,   59,   65,   66,   66,   67,   68,   74,
   74,   69,   75,   75,   73,   73,   73,   73,   73,   73,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
    3,   10,   10,    8,    8,    8,    9,    9,    9,    9,
    4,    5,    6,    7,   70,   70,   70,   71,   72,   72,
   72,   72,   72,   77,   78,   79,   80,   81,   61,   62,
   63,   64,   12,   12,   11,   11,   26,   26,   83,   83,
   84,   84,   85,   86,   13,   13,   13,   13,   13,   14,
   14,   14,   88,   14,   89,   14,   90,   14,   92,   14,
   93,   14,   94,   14,   95,   14,   96,   14,   97,   14,
   14,   98,   14,   99,   14,   14,  100,   14,  101,   14,
   14,   14,   14,   14,   14,   14,   15,   15,   16,   16,
   16,   16,   25,   25,  103,  103,  102,  105,  105,   27,
   27,  107,   29,   29,  109,  109,  110,   32,  111,  111,
  114,  114,  115,  115,  112,  112,  116,  116,  117,  113,
  113,  118,  118,  119,  119,   30,   30,  121,  121,  121,
   31,   31,  122,  122,  123,  125,  123,  123,   17,  108,
  126,  126,   76,   76,  106,  106,   54,   54,  127,  128,
   50,   50,   50,   50,   50,  130,   50,  131,  132,   91,
   91,   91,   91,   91,  133,  133,   82,   40,   40,  129,
  134,  134,  135,  136,  135,  135,   34,  104,  137,  138,
  138,  138,  138,   87,   87,   87,   87,   87,  124,   18,
  120,
};
const short yylen[] = {                                         2,
    0,    0,   14,    1,    2,    2,    1,    2,    2,    2,
    1,    0,    1,    2,    5,    1,    2,    5,    4,    7,
    1,    0,    5,    1,    2,    4,    3,    2,    2,    4,
    1,    0,    1,    2,    4,    3,    1,    2,    5,    3,
    1,    2,    1,    1,    5,    4,    1,    2,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    3,    5,    4,    4,    4,    2,
    0,    4,    1,    1,    5,    9,    8,    8,    7,    4,
    3,    2,    3,    3,    3,    3,    3,    1,    1,    1,
    2,    1,    1,    7,    7,    7,    1,    1,    1,    1,
    7,    7,    7,    7,    7,    7,    7,    5,    1,    1,
    1,    1,    1,    7,    7,    7,    7,    7,    5,    4,
    5,    4,    1,    2,    3,    5,    1,    0,    1,    2,
    1,    1,    5,    4,    3,    2,    3,    3,    1,    3,
    3,    3,    0,    4,    0,    4,    0,    4,    0,    4,
    0,    4,    0,    4,    0,    4,    0,    4,    0,    4,
    1,    0,    4,    0,    4,    2,    0,    4,    0,    4,
    3,    3,    3,    3,    3,    3,    1,    1,    1,    1,
    1,    1,    1,    2,    1,    1,    6,    4,    0,    1,
    2,    3,    1,    0,    1,    2,    5,    3,    1,    0,
    1,    2,    4,    6,    1,    0,    1,    2,    4,    1,
    0,    1,    2,    4,    4,    1,    2,    4,    4,    4,
    1,    0,    1,    2,    6,    0,    7,    4,    7,    6,
    2,    0,    3,    1,    3,    1,    1,    3,    1,    1,
    1,    1,    1,    2,    2,    0,    4,    1,    1,    1,
    3,    1,    2,    4,    1,    2,    1,    1,    2,    3,
    1,    2,    1,    0,    3,    1,    1,    1,    1,    1,
    2,    2,    2,    1,    1,    3,    2,    4,    1,    1,
    1,
};
const short yydefred[] = {                                      0,
    0,    0,    0,    4,  267,    6,    0,    0,    5,    7,
    9,    0,    1,    8,    0,    0,   13,    0,    0,    0,
    0,   16,   14,    0,    0,    0,   21,    0,   24,    0,
   17,  258,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   51,    0,   47,   49,   50,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
  109,  110,  111,  112,  113,    0,    0,   25,    0,    0,
   15,  259,    0,   27,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   88,   89,    0,  239,  240,    0,
    0,    0,  243,  242,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   48,  183,    0,   29,
    0,    0,    0,   33,    0,    0,   28,   26,    0,    0,
  237,    0,    0,    0,    0,   65,   73,   74,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  264,  263,  266,
    0,  261,  246,    0,  244,  245,    0,    0,    0,    0,
    0,  123,    0,    0,    0,    0,    0,    0,  268,  185,
    0,  186,    0,    0,    2,    0,  129,  131,  132,  184,
    0,    0,    0,    0,   37,   34,    0,   18,    0,   68,
   69,    0,    0,    0,   67,   72,   81,    0,    0,    0,
   86,   87,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   97,   98,   99,  100,   92,   93,   90,    0,  260,
  262,    0,    0,    0,    0,    0,    0,    0,    0,  257,
    0,  120,  124,    0,  122,    0,    0,    0,    0,    0,
    0,    0,    0,  130,   30,   36,    0,    0,    0,    0,
    0,   38,   41,   43,   44,    0,  119,  238,   66,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   91,  265,
  247,    0,    0,    0,  121,    0,  108,    0,    0,  125,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  161,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  139,    0,    0,  190,
   35,   40,    0,    0,    0,   42,   20,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  233,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  180,  181,  182,  177,  178,  179,  166,  162,  167,  164,
  169,    0,  145,  147,    0,    0,  151,  153,    0,  157,
  159,    0,    0,    0,  136,    0,    0,    0,  134,    0,
    0,    0,  191,    0,  195,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   79,    0,    0,  105,  106,
  107,  126,  118,  114,  115,  116,  117,    0,  187,  133,
    0,    0,    0,    0,  140,    0,    0,    0,    0,  141,
    0,    0,  142,    0,    0,    0,  171,  175,  172,  176,
  173,  174,  135,  137,    0,    0,  192,  280,    0,    0,
    0,    0,    0,  216,  196,   39,    0,   46,    0,    0,
    0,    0,    0,    0,    0,   78,   77,    0,    0,    0,
  250,  163,  248,  249,    0,  252,  168,  165,  170,  269,
    0,  144,  274,    0,  275,  146,  148,  150,  152,  154,
  156,  158,  160,    0,    0,    0,    0,    0,    0,    0,
  217,    0,  223,   45,    0,    0,    0,    0,    0,    0,
    0,   76,  188,  255,    0,    0,  253,    0,  270,    0,
    0,  277,    0,    0,    0,    0,    0,    0,    0,    3,
    0,    0,  201,  224,   94,   95,   96,  101,  102,  103,
  104,  251,  256,    0,  271,  276,  272,  273,    0,    0,
    0,  197,  218,  219,  220,  279,    0,    0,    0,    0,
    0,  207,  202,  254,  278,    0,    0,  228,    0,    0,
    0,  198,    0,  212,  208,    0,  230,  226,    0,    0,
  203,    0,  281,    0,    0,    0,  213,  231,    0,  225,
    0,  209,    0,    0,    0,  227,  204,  214,    0,  215,
    0,    0,    0,  229,
};
const short yydgoto[] = {                                       2,
   94,   95,  211,  212,  213,  214,  215,  216,  217,  218,
  162,  163,  306,  307,  346,  347,  564,  565,    3,    8,
   13,   26,   19,   54,  116,  175,  309,  243,  372,  433,
  480,  510,    4,  100,   10,   15,   21,   16,   17,   33,
   22,   27,   28,   77,  122,  184,  251,   29,   85,  101,
  123,  124,  185,  132,  253,  254,  255,   55,   56,   57,
   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,
   68,   69,   70,  135,  139,  228,   71,   72,   73,   74,
   75,  451,  176,  177,  178,  179,  462,  406,  407,  408,
  463,  409,  411,  412,  414,  415,  416,  401,  403,  402,
  404,  118,  426,  172,  339,  229,  310,  427,  374,  375,
  511,  540,  552,  512,  513,  541,  542,  553,  554,  566,
  434,  482,  483,  537,  569,  557,  102,  103,  104,  222,
  455,  456,  495,  151,  152,  219,  465,  500,
};
const short yysindex[] = {                                   -198,
 -256,    0, -154,    0,    0,    0, -256,  -74,    0,    0,
    0, -256,    0,    0, -176, -151,    0,   -6, -148, -256,
 -176,    0,    0, -256, -256,  626,    0, -158,    0,  -80,
    0,    0,  -94,  -29, -256, -256, -256, -256, -256, -256,
  -26,  -40,  -40,  -40,  -40,  -40,   24,  -40,  -40,  -40,
  -40,  -40,    0,  484,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  -77, -122,    0, -256, -256,
    0,    0,  -40,    0,  112,  -51,  -82, -256,  -19,  135,
 -187,  -26,  -26,   84,    0,    0,   58,    0,    0,  152,
  -40,  -76,    0,    0,  -40,  -40,  -40,  -40,  -56,  -40,
  -40,  -40,  -40,  -40, -149, -140,    0,    0, -256,    0,
 -256,  -13, -122,    0,  153,  -69,    0,    0,  -40,  223,
    0,   17, -256,  254,  261,    0,    0,    0,  284, -130,
  -34,  -26,  -26,  -26,  -26,  -26,  288,    0,    0,    0,
   45,    0,    0,  312,    0,    0,  344,  354, -256, -256,
   95,    0,  -81,  374,  158,  379,  383,  384,    0,    0,
  187,    0,  -40,  -40,    0,    6,    0,    0,    0,    0,
   28,  -18, -256,  -61,    0,    0, -256,    0,  400,    0,
    0, -256,  417,  405,    0,    0,    0, -130, -116, -126,
    0,    0,  -40,  -40,  -40,  -40,  -40,  -40,  -40,  191,
  299,    0,    0,    0,    0,    0,    0,    0, -256,    0,
    0, -256,  -40,  -40,  -40,  409,  412,  413,  445,    0,
  -10,    0,    0,  -40,    0,  -40,  -40,  -40,  -40,  -40,
  -40,  385,  240,    0,    0,    0,  446,  165,  -40,  -40,
  138,    0,    0,    0,    0,   35,    0,    0,    0,  -40,
  -40,  -40,  -40,  -40,  -40,  -40,  386,  235,    0,    0,
    0, -256, -256, -256,    0, -256,    0, -256,  -56,    0,
  -40,  -40,  -40,  -40,  -40,  228,  385, -157, -134,  -93,
    0,   34,   34,   34, -157,   34,   34,   34,   34,   34,
 -157, -157, -157,  385,  385,  -44,    0, -256, -206,    0,
    0,    0, -256,  -40,  385,    0,    0,  473,  474,  475,
  476,  479,  481,  482,  311,  418,  483,  485,  486,  417,
    0,  -70,  488,  492,  493,  495,  497, -256,  498,  -42,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  251,    0,    0,    0,  250,    0,    0,  248,    0,
    0,  115,  247, -108,    0,   78,  385,  385,    0, -149,
  242,  141,    0,  269,    0,   26,  385,  -39,  -40,  -40,
  -40,  -40,  -40,  -40,  -40,    0,  340,  381,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  285,    0,    0,
   11,   11,   11,   11,    0,   23,   23,   23,   11,    0,
   11,   11,    0,   11,   11,   11,    0,    0,    0,    0,
    0,    0,    0,    0,  256,  532,    0,    0,  242, -256,
 -256, -256,  114,    0,    0,    0,   38,    0, -256, -256,
 -256,  -40,  -40,  -40,  -40,    0,    0,  434, -256,   95,
    0,    0,    0,    0,  -73,    0,    0,    0,    0,    0,
  160,    0,    0,  -90,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -256, -149, -149, -149, -149, -256,  290,
    0,  278,    0,    0,  537,  538,  539,  540,  541,  542,
  543,    0,    0,    0,   36,   95,    0,  -97,    0,  -71,
  160,    0,  545, -149,  549,  560,  562,  365, -256,    0,
  321,  290,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   44,    0,    0,    0,    0,  -62,  -58,
 -256,    0,    0,    0,    0,    0,  -36,  242, -256,  322,
  321,    0,    0,    0,    0,  566,   27,    0,   19, -149,
 -234,    0,  322,    0,    0, -256,    0,    0, -149,  242,
    0, -149,    0,  242,  580,  295,    0,    0, -149,    0,
 -149,    0, -149,  242, -149,    0,    0,    0,  582,    0,
  242,  586,  242,    0,
};
const short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,  377,    0,    0,
    0,    0,    0,    0,    0,  378,    0,    0,  658,    0,
  527,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  352,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  589,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  427,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  387,    0,    0,    0,    0,
    0,    0,  362,    0,  -33,    0,    0,    0,    0,    0,
    0,    0,    0,  589,    0,    0,    0,    0,    0,   64,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  389,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  595,    0,    0,    0,    0,   75,  -23,   52,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  561,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   21,    0,   77,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  691,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  593,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  601,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  175,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   29,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   31,    0,    0,   40,    0,    0,    0,   39,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  178,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -37,    0,    0,    0,    0,    0,
    0,    0,    1,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    8,
    0,   12,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    3,   16,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  641,
   13,    0,    0,    0,    0,   89,    0,    0,    0,    0,
    0,    0,  661,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
  351,    0, -273,    0,    0,    0,    0,    0,    0, -184,
 -121,  394, -175,    0,  229,  108,   98, -361,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  660,   -1,  656,    0,    0,    0,  649,  -20,
  657,    0,    0,    0,    0,    0,    0,  651,  -30,  406,
    0,  557,  502,  -88,  430,    0,    0,  653,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  571,    0, -401,    0,    0,    0,    0,
    0, -156,    0,  533,    0,    0,   94,    0,    0,    0,
  591,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  592,  598,    0,    0, -227,  407,  439,    0,  341,
    0,    0,    0,    0,  206,    0,  180,    0,  166,  156,
  298,    0,  241,    0,    0,    0,  614,  630,    5,    0,
   92,    0, -392,    0,  581,    0,  -38,  232,
};
#define YYTABLESIZE 1046
const short yytable[] = {                                       6,
  222,   99,  206,  138,  231,   11,  197,  200,  547,  429,
   18,  221,  205,   93,  369,  199,  400,   84,   30,  438,
  236,  138,   32,   34,  133,   19,  269,  522,  235,   84,
   81,   82,  501,   86,   87,   88,   89,   90,   91,   96,
  246,  233,   80,  232,  193,  119,   97,  493,  280,  496,
  331,  387,   99,  526,  392,  188,  130,  308,  134,  126,
  192,    1,  544,  560,   99,  236,  545,  475,  498,  192,
    5,  558,  143,  235,  120,  191,  234,  125,   32,  236,
  155,  149,   97,   20,  436,   98,  131,  235,  232,  148,
   96,   96,   85,  371,  428,  149,  484,  563,  181,   84,
  155,  150,  148,  524,   82,    1,  156,   12,  529,    7,
  398,  340,  279,  170,  448,   83,   24,   32,  423,  182,
  173,  174,   25,   76,   82,  341,  342,  343,  365,  366,
  348,  131,   25,  450,  349,  234,   98,  137,  138,  378,
   96,   96,   96,   96,   96,  461,  109,  232,   98,  149,
  115,  247,  245,  143,  568,  150,  143,  226,  227,  317,
  522,  155,  149,  121,  155,  149,  256,   97,  544,  220,
  128,  350,  344,  345,   85,  351,  549,    5,  169,   82,
   97,  248,   79,  161,   12,   32,   82,  330,   83,    7,
  258,  424,  425,  136,  161,  142,  153,   83,  571,  145,
  146,  437,  269,  145,  146,  142,  147,  144,  161,  421,
  233,  422,  579,  145,  146,  236,  235,  270,  129,  582,
  271,  584,  313,  312,  376,  183,   19,  249,  250,  230,
  460,   19,    5,   19,   19,   19,  230,  460,   19,   19,
   19,   83,   19,   19,   19,   19,   19,   19,   19,    5,
    5,   83,   83,  230,   82,  230,  460,    5,   19,   19,
   19,   19,   19,  269,  230,  460,  173,  174,  230,  460,
  327,  328,  329,  183,  131,  187,  227,  367,  368,  367,
  368,  190,  367,  368,  236,  138,    5,  142,  143,  144,
    5,  169,  235,  494,   92,  145,  146,  133,  497,   84,
    5,  222,  222,  222,  494,  206,  370,  497,  236,  200,
  200,  131,  221,  221,  221,  205,  235,  199,  199,  195,
  236,  236,  236,  236,  236,  236,  236,  236,  235,  235,
  235,  235,  235,  235,  235,  235,  227,  230,  523,  494,
  234,  523,  196,  527,  494,    5,  169,  236,  236,  230,
  460,  179,  232,    5,    5,  235,  235,  143,  143,  367,
  368,    5,  230,  344,  345,  155,  149,  523,  170,  223,
  230,    5,  523,  527,   85,   85,  234,  234,  234,  234,
  234,  234,  234,  234,    5,   82,   82,   82,  232,  232,
  232,  232,  232,  232,  232,  232,   83,   83,   83,  367,
  368,  224,  356,  234,  234,  142,  143,  144,  362,  363,
  364,  225,  210,  145,  146,  232,  232,  430,  431,  432,
  479,  230,  499,  268,  305,  502,  249,  250,  476,  477,
  478,  234,  417,  418,  419,  386,  237,  485,  486,  487,
  238,  239,  140,  141,  430,  431,  432,  227,  105,  106,
  107,  108,  240,  110,  111,  112,  113,  114,  257,  525,
  192,  528,  499,  259,  446,  267,  241,  275,  241,  276,
  241,  277,  503,  170,  170,  170,  170,  508,  194,  194,
  194,  193,  193,  193,  241,  241,  230,  460,  127,  278,
  525,  528,  198,  199,  200,  201,  202,  464,  464,  464,
  466,  467,  170,  308,  311,  447,  154,  538,  325,  326,
  157,  158,  159,  160,  338,  164,  165,  166,  167,  168,
  352,  353,  354,  355,  357,  358,  359,  360,  361,  546,
  379,  380,  381,  382,  189,  170,  383,  550,  384,  385,
  388,  389,   53,  390,  391,  559,  393,  170,  170,  241,
  394,  395,  241,  396,  227,  397,  399,  170,  492,  405,
  170,  410,  413,  203,  204,  205,  420,  170,  371,  170,
  428,  170,  449,  170,  203,  204,  205,  367,  241,  242,
  206,  207,  208,  209,  479,   10,  203,  204,  205,  474,
  509,  206,  207,  208,  209,  515,  516,  517,  518,  519,
  520,  521,  531,  206,  207,  208,  209,  533,  260,  261,
  262,  263,  264,  265,  266,  203,  204,  205,  534,   80,
  535,  536,  539,  556,  551,  574,  563,  581,  272,  273,
  274,  583,  206,  207,  208,  209,   12,   11,   32,  281,
  211,  282,  283,  284,  285,  286,  287,   71,   31,  288,
  128,   75,  127,   70,  314,  315,  203,  204,  205,  189,
  210,  573,    9,   14,   23,  318,  319,  320,  321,  322,
  323,  324,  332,  206,  207,  208,  209,   31,   78,  186,
  316,  289,  290,  291,   53,  252,  333,  334,  335,  336,
  337,  241,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  194,  304,  117,  180,  244,  203,
  204,  205,  171,  241,  435,  373,   22,  543,  567,  377,
  555,  575,  514,  241,  241,  241,  206,  207,  208,  209,
  481,  221,  530,    0,  241,  241,  241,  241,  241,  241,
  241,  241,  241,  241,  241,  241,    0,  241,   35,   23,
   36,   37,   38,  241,    0,   39,   40,   41,    0,   42,
   43,   44,   45,   46,    0,   47,    0,    0,    0,    0,
    0,    0,    0,    0,  115,   48,   49,   50,   51,   52,
    0,    0,    0,    0,  439,  440,  441,  442,  443,  444,
  445,   10,    0,   10,   10,   10,    0,    0,   10,   10,
   10,    0,   10,   10,   10,   10,   10,   10,   10,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   10,   10,
   10,   10,   10,    0,    0,   80,    0,   80,   80,   80,
    0,    0,   80,   80,   80,    0,   80,   80,   80,   80,
   80,    0,   80,    0,    0,    0,    0,  488,  489,  490,
  491,   80,   80,   80,   80,   80,   80,   75,    0,   75,
   75,   75,    0,    0,   75,   75,   75,    0,   75,   75,
   75,   75,   75,    0,   75,    0,    0,    0,    0,    0,
    0,    0,    0,   75,   75,   75,   75,   75,   75,    0,
   35,    0,   36,   37,   38,    0,    0,   39,   40,   41,
    0,   42,   43,   44,   45,   46,    0,   47,    0,    0,
    0,    0,    0,  504,  505,  506,  507,   48,   49,   50,
   51,   52,   22,    0,   22,   22,   22,    0,    0,   22,
   22,   22,    0,   22,   22,   22,   22,   22,    0,   22,
    0,    0,  532,    0,    0,    0,    0,    0,    0,   22,
   22,   22,   22,   22,    0,   23,    0,   23,   23,   23,
    0,    0,   23,   23,   23,    0,   23,   23,   23,   23,
   23,    0,   23,    0,    0,  548,    0,    0,    0,    0,
    0,    0,   23,   23,   23,   23,   23,  561,  562,    0,
    0,  452,  457,  458,  459,    0,    0,  570,    0,  468,
  572,  469,  470,    0,  471,  472,  473,  576,    0,  577,
    0,  578,    0,  580,  453,  453,  453,  453,    0,  453,
  453,  453,  453,    0,  453,  453,    0,  453,  453,  453,
  454,  454,  454,  454,    0,  454,  454,  454,  454,    0,
  454,  454,    0,  454,  454,  454,
};
const short yycheck[] = {                                       1,
    0,   42,    0,   41,  161,    7,   41,    0,   45,  371,
   12,    0,    0,   40,   59,    0,   59,   41,   20,   59,
    0,   59,   24,   25,   44,   59,  211,  125,    0,   59,
  125,   33,  123,   35,   36,   37,   38,   39,   40,   41,
   59,  163,  123,  125,  133,  123,  123,  449,   59,  123,
  278,  325,   42,  125,  125,  125,   87,  264,   89,   80,
   44,  260,  125,   45,   42,   45,  125,  429,  461,   44,
  327,   45,   42,   45,   76,   59,    0,   79,   80,   59,
   42,   42,  123,  260,   59,  126,   88,   59,    0,   45,
   92,   93,   41,  300,  329,   97,   59,  332,  119,  123,
  102,   97,   45,  496,   41,  260,  102,  259,  501,  264,
  338,  287,  123,  115,  388,   41,  123,  119,   41,  121,
  261,  262,  281,  282,  126,  283,  284,  285,  304,  305,
  265,  133,  281,  123,  269,   59,  126,  325,  326,  315,
  142,  143,  144,  145,  146,  123,  123,   59,  126,  151,
  291,  182,  125,  123,  556,  151,  126,  159,  160,  125,
  125,  123,  123,  286,  126,  126,  187,  123,  125,  125,
   59,  265,  330,  331,  123,  269,  538,  327,  328,  181,
  123,  183,  263,  265,  259,  187,  123,  276,  271,  264,
  192,  367,  368,   59,  265,  322,   45,  123,  560,  330,
  331,  377,  387,  330,  331,  322,  123,  324,  265,  318,
  332,  320,  574,  330,  331,   58,   59,  219,  270,  581,
  222,  583,   58,   59,  313,  287,  260,  289,  290,  327,
  328,  265,  327,  267,  268,  269,  327,  328,  272,  273,
  274,  271,  276,  277,  278,  279,  280,  281,  282,  327,
  327,  271,  271,  327,  256,  327,  328,  327,  292,  293,
  294,  295,  296,  448,  327,  328,  261,  262,  327,  328,
  272,  273,  274,  287,  276,  123,  278,  322,  323,  322,
  323,   59,  322,  323,  264,  323,  327,  322,  323,  324,
  327,  328,  264,  450,  321,  330,  331,   44,  455,  323,
  327,  301,  302,  303,  461,  303,  308,  464,  288,  302,
  303,  313,  301,  302,  303,  303,  288,  302,  303,   59,
  300,  301,  302,  303,  304,  305,  306,  307,  300,  301,
  302,  303,  304,  305,  306,  307,  338,  327,  495,  496,
  264,  498,   59,  500,  501,  327,  328,  327,  328,  327,
  328,  312,  264,  327,  327,  327,  328,  327,  328,  322,
  323,  327,  327,  330,  331,  327,  327,  524,  370,   58,
  327,  327,  529,  530,  323,  324,  300,  301,  302,  303,
  304,  305,  306,  307,  327,  322,  323,  324,  300,  301,
  302,  303,  304,  305,  306,  307,  322,  323,  324,  322,
  323,   58,  295,  327,  328,  322,  323,  324,  301,  302,
  303,   58,  125,  330,  331,  327,  328,  304,  305,  306,
  307,  327,  461,  125,   40,  464,  289,  290,  430,  431,
  432,   58,  318,  319,  320,  125,   58,  439,  440,  441,
   58,   58,   92,   93,  304,  305,  306,  449,   43,   44,
   45,   46,  266,   48,   49,   50,   51,   52,   59,  498,
   44,  500,  501,   59,  125,  275,   40,   59,   42,   58,
   44,   59,  474,  475,  476,  477,  478,  479,  304,  305,
  306,  304,  305,  306,   58,   59,  327,  328,   83,   45,
  529,  530,  142,  143,  144,  145,  146,  406,  407,  408,
  407,  408,  504,  264,   59,  125,  101,  509,  123,  275,
  105,  106,  107,  108,  287,  110,  111,  112,  113,  114,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  531,
   58,   58,   58,   58,  129,  537,   58,  539,   58,   58,
  123,   59,   59,   59,   59,  547,   59,  549,  550,  123,
   59,   59,  126,   59,  556,   59,   59,  559,  125,  309,
  562,  312,  315,  276,  277,  278,  320,  569,  300,  571,
  329,  573,  288,  575,  276,  277,  278,  322,  173,  174,
  293,  294,  295,  296,  307,   59,  276,  277,  278,   58,
  301,  293,  294,  295,  296,   59,   59,   59,   59,   59,
   59,   59,   58,  293,  294,  295,  296,   59,  203,  204,
  205,  206,  207,  208,  209,  276,  277,  278,   59,   59,
   59,  257,  302,   58,  303,   46,  332,   46,  223,  224,
  225,   46,  293,  294,  295,  296,  260,  260,  287,  234,
    0,  236,  237,  238,  239,  240,  241,   59,  287,  265,
  264,   59,  264,   59,  249,  250,  276,  277,  278,   59,
    0,  564,    3,    8,   16,  260,  261,  262,  263,  264,
  265,  266,  279,  293,  294,  295,  296,   21,   28,  123,
  251,  297,  298,  299,   59,  184,  281,  282,  283,  284,
  285,  265,  308,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,  319,  134,  321,   54,  116,  176,  276,
  277,  278,  115,  287,  374,  309,   59,  512,  553,  314,
  541,  566,  482,  297,  298,  299,  293,  294,  295,  296,
  433,  151,  501,   -1,  308,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,  319,   -1,  321,  265,   59,
  267,  268,  269,  327,   -1,  272,  273,  274,   -1,  276,
  277,  278,  279,  280,   -1,  282,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  291,  292,  293,  294,  295,  296,
   -1,   -1,   -1,   -1,  379,  380,  381,  382,  383,  384,
  385,  265,   -1,  267,  268,  269,   -1,   -1,  272,  273,
  274,   -1,  276,  277,  278,  279,  280,  281,  282,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  292,  293,
  294,  295,  296,   -1,   -1,  265,   -1,  267,  268,  269,
   -1,   -1,  272,  273,  274,   -1,  276,  277,  278,  279,
  280,   -1,  282,   -1,   -1,   -1,   -1,  442,  443,  444,
  445,  291,  292,  293,  294,  295,  296,  265,   -1,  267,
  268,  269,   -1,   -1,  272,  273,  274,   -1,  276,  277,
  278,  279,  280,   -1,  282,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  291,  292,  293,  294,  295,  296,   -1,
  265,   -1,  267,  268,  269,   -1,   -1,  272,  273,  274,
   -1,  276,  277,  278,  279,  280,   -1,  282,   -1,   -1,
   -1,   -1,   -1,  475,  476,  477,  478,  292,  293,  294,
  295,  296,  265,   -1,  267,  268,  269,   -1,   -1,  272,
  273,  274,   -1,  276,  277,  278,  279,  280,   -1,  282,
   -1,   -1,  504,   -1,   -1,   -1,   -1,   -1,   -1,  292,
  293,  294,  295,  296,   -1,  265,   -1,  267,  268,  269,
   -1,   -1,  272,  273,  274,   -1,  276,  277,  278,  279,
  280,   -1,  282,   -1,   -1,  537,   -1,   -1,   -1,   -1,
   -1,   -1,  292,  293,  294,  295,  296,  549,  550,   -1,
   -1,  401,  402,  403,  404,   -1,   -1,  559,   -1,  409,
  562,  411,  412,   -1,  414,  415,  416,  569,   -1,  571,
   -1,  573,   -1,  575,  401,  402,  403,  404,   -1,  406,
  407,  408,  409,   -1,  411,  412,   -1,  414,  415,  416,
  401,  402,  403,  404,   -1,  406,  407,  408,  409,   -1,
  411,  412,   -1,  414,  415,  416,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 332
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'",0,"','","'-'","'.'",0,0,0,0,0,0,0,0,0,0,0,"':'",
"';'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'","'~'",0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"PATH","CLONE","COMMON","CLASS","CONSTRAIN","VALIDATETRANS",
"INHERITS","SID","ROLE","ROLES","TYPEALIAS","TYPEATTRIBUTE","TYPE","TYPES",
"ALIAS","ATTRIBUTE","BOOL","IF","ELSE","TYPE_TRANSITION","TYPE_MEMBER",
"TYPE_CHANGE","ROLE_TRANSITION","RANGE_TRANSITION","SENSITIVITY","DOMINANCE",
"DOM","DOMBY","INCOMP","CATEGORY","LEVEL","RANGE","MLSCONSTRAIN",
"MLSVALIDATETRANS","USER","NEVERALLOW","ALLOW","AUDITALLOW","AUDITDENY",
"DONTAUDIT","SOURCE","TARGET","SAMEUSER","FSCON","PORTCON","NETIFCON","NODECON",
"FSUSEXATTR","FSUSETASK","FSUSETRANS","GENFSCON","U1","U2","U3","R1","R2","R3",
"T1","T2","T3","L1","L2","H1","H2","NOT","AND","OR","XOR","CTRUE","CFALSE",
"IDENTIFIER","USER_IDENTIFIER","NUMBER","EQUALS","NOTEQUAL","IPV6_ADDR",
};
const char * const yyrule[] = {
"$accept : policy",
"$$1 :",
"$$2 :",
"policy : classes initial_sids access_vectors $$1 opt_mls te_rbac users opt_constraints $$2 initial_sid_contexts opt_fs_contexts fs_uses opt_genfs_contexts net_contexts",
"classes : class_def",
"classes : classes class_def",
"class_def : CLASS identifier",
"initial_sids : initial_sid_def",
"initial_sids : initial_sids initial_sid_def",
"initial_sid_def : SID identifier",
"access_vectors : opt_common_perms av_perms",
"opt_common_perms : common_perms",
"opt_common_perms :",
"common_perms : common_perms_def",
"common_perms : common_perms common_perms_def",
"common_perms_def : COMMON identifier '{' identifier_list '}'",
"av_perms : av_perms_def",
"av_perms : av_perms av_perms_def",
"av_perms_def : CLASS identifier '{' identifier_list '}'",
"av_perms_def : CLASS identifier INHERITS identifier",
"av_perms_def : CLASS identifier INHERITS identifier '{' identifier_list '}'",
"opt_mls : mls",
"opt_mls :",
"mls : sensitivities dominance opt_categories levels mlspolicy",
"sensitivities : sensitivity_def",
"sensitivities : sensitivities sensitivity_def",
"sensitivity_def : SENSITIVITY identifier alias_def ';'",
"sensitivity_def : SENSITIVITY identifier ';'",
"alias_def : ALIAS names",
"dominance : DOMINANCE identifier",
"dominance : DOMINANCE '{' identifier_list '}'",
"opt_categories : categories",
"opt_categories :",
"categories : category_def",
"categories : categories category_def",
"category_def : CATEGORY identifier alias_def ';'",
"category_def : CATEGORY identifier ';'",
"levels : level_def",
"levels : levels level_def",
"level_def : LEVEL identifier ':' id_comma_list ';'",
"level_def : LEVEL identifier ';'",
"mlspolicy : mlspolicy_decl",
"mlspolicy : mlspolicy mlspolicy_decl",
"mlspolicy_decl : mlsconstraint_def",
"mlspolicy_decl : mlsvalidatetrans_def",
"mlsconstraint_def : MLSCONSTRAIN names names cexpr ';'",
"mlsvalidatetrans_def : MLSVALIDATETRANS names cexpr ';'",
"te_rbac : te_rbac_decl",
"te_rbac : te_rbac te_rbac_decl",
"te_rbac_decl : te_decl",
"te_rbac_decl : rbac_decl",
"te_rbac_decl : ';'",
"rbac_decl : role_type_def",
"rbac_decl : role_dominance",
"rbac_decl : role_trans_def",
"rbac_decl : role_allow_def",
"te_decl : attribute_def",
"te_decl : type_def",
"te_decl : typealias_def",
"te_decl : typeattribute_def",
"te_decl : bool_def",
"te_decl : transition_def",
"te_decl : range_trans_def",
"te_decl : te_avtab_def",
"te_decl : cond_stmt_def",
"attribute_def : ATTRIBUTE identifier ';'",
"type_def : TYPE identifier alias_def opt_attr_list ';'",
"type_def : TYPE identifier opt_attr_list ';'",
"typealias_def : TYPEALIAS identifier alias_def ';'",
"typeattribute_def : TYPEATTRIBUTE identifier id_comma_list ';'",
"opt_attr_list : ',' id_comma_list",
"opt_attr_list :",
"bool_def : BOOL identifier bool_val ';'",
"bool_val : CTRUE",
"bool_val : CFALSE",
"cond_stmt_def : IF cond_expr '{' cond_pol_list '}'",
"cond_stmt_def : IF cond_expr '{' cond_pol_list '}' ELSE '{' cond_pol_list '}'",
"cond_stmt_def : IF cond_expr '{' cond_pol_list '}' ELSE '{' '}'",
"cond_stmt_def : IF cond_expr '{' '}' ELSE '{' cond_pol_list '}'",
"cond_stmt_def : IF cond_expr '{' '}' ELSE '{' '}'",
"cond_stmt_def : IF cond_expr '{' '}'",
"cond_expr : '(' cond_expr ')'",
"cond_expr : NOT cond_expr",
"cond_expr : cond_expr AND cond_expr",
"cond_expr : cond_expr OR cond_expr",
"cond_expr : cond_expr XOR cond_expr",
"cond_expr : cond_expr EQUALS cond_expr",
"cond_expr : cond_expr NOTEQUAL cond_expr",
"cond_expr : cond_expr_prim",
"cond_expr_prim : identifier",
"cond_pol_list : cond_rule_def",
"cond_pol_list : cond_pol_list cond_rule_def",
"cond_rule_def : cond_transition_def",
"cond_rule_def : cond_te_avtab_def",
"cond_transition_def : TYPE_TRANSITION names names ':' names identifier ';'",
"cond_transition_def : TYPE_MEMBER names names ':' names identifier ';'",
"cond_transition_def : TYPE_CHANGE names names ':' names identifier ';'",
"cond_te_avtab_def : cond_allow_def",
"cond_te_avtab_def : cond_auditallow_def",
"cond_te_avtab_def : cond_auditdeny_def",
"cond_te_avtab_def : cond_dontaudit_def",
"cond_allow_def : ALLOW names names ':' names names ';'",
"cond_auditallow_def : AUDITALLOW names names ':' names names ';'",
"cond_auditdeny_def : AUDITDENY names names ':' names names ';'",
"cond_dontaudit_def : DONTAUDIT names names ':' names names ';'",
"transition_def : TYPE_TRANSITION names names ':' names identifier ';'",
"transition_def : TYPE_MEMBER names names ':' names identifier ';'",
"transition_def : TYPE_CHANGE names names ':' names identifier ';'",
"range_trans_def : RANGE_TRANSITION names names mls_range_def ';'",
"te_avtab_def : allow_def",
"te_avtab_def : auditallow_def",
"te_avtab_def : auditdeny_def",
"te_avtab_def : dontaudit_def",
"te_avtab_def : neverallow_def",
"allow_def : ALLOW names names ':' names names ';'",
"auditallow_def : AUDITALLOW names names ':' names names ';'",
"auditdeny_def : AUDITDENY names names ':' names names ';'",
"dontaudit_def : DONTAUDIT names names ':' names names ';'",
"neverallow_def : NEVERALLOW names names ':' names names ';'",
"role_type_def : ROLE identifier TYPES names ';'",
"role_dominance : DOMINANCE '{' roles '}'",
"role_trans_def : ROLE_TRANSITION names names identifier ';'",
"role_allow_def : ALLOW names names ';'",
"roles : role_def",
"roles : roles role_def",
"role_def : ROLE identifier_push ';'",
"role_def : ROLE identifier_push '{' roles '}'",
"opt_constraints : constraints",
"opt_constraints :",
"constraints : constraint_decl",
"constraints : constraints constraint_decl",
"constraint_decl : constraint_def",
"constraint_decl : validatetrans_def",
"constraint_def : CONSTRAIN names names cexpr ';'",
"validatetrans_def : VALIDATETRANS names cexpr ';'",
"cexpr : '(' cexpr ')'",
"cexpr : NOT cexpr",
"cexpr : cexpr AND cexpr",
"cexpr : cexpr OR cexpr",
"cexpr : cexpr_prim",
"cexpr_prim : U1 op U2",
"cexpr_prim : R1 role_mls_op R2",
"cexpr_prim : T1 op T2",
"$$3 :",
"cexpr_prim : U1 op $$3 user_names_push",
"$$4 :",
"cexpr_prim : U2 op $$4 user_names_push",
"$$5 :",
"cexpr_prim : U3 op $$5 user_names_push",
"$$6 :",
"cexpr_prim : R1 op $$6 names_push",
"$$7 :",
"cexpr_prim : R2 op $$7 names_push",
"$$8 :",
"cexpr_prim : R3 op $$8 names_push",
"$$9 :",
"cexpr_prim : T1 op $$9 names_push",
"$$10 :",
"cexpr_prim : T2 op $$10 names_push",
"$$11 :",
"cexpr_prim : T3 op $$11 names_push",
"cexpr_prim : SAMEUSER",
"$$12 :",
"cexpr_prim : SOURCE ROLE $$12 names_push",
"$$13 :",
"cexpr_prim : TARGET ROLE $$13 names_push",
"cexpr_prim : ROLE role_mls_op",
"$$14 :",
"cexpr_prim : SOURCE TYPE $$14 names_push",
"$$15 :",
"cexpr_prim : TARGET TYPE $$15 names_push",
"cexpr_prim : L1 role_mls_op L2",
"cexpr_prim : L1 role_mls_op H2",
"cexpr_prim : H1 role_mls_op L2",
"cexpr_prim : H1 role_mls_op H2",
"cexpr_prim : L1 role_mls_op H1",
"cexpr_prim : L2 role_mls_op H2",
"op : EQUALS",
"op : NOTEQUAL",
"role_mls_op : op",
"role_mls_op : DOM",
"role_mls_op : DOMBY",
"role_mls_op : INCOMP",
"users : user_def",
"users : users user_def",
"user_id : identifier",
"user_id : user_identifier",
"user_def : USER user_id ROLES names opt_mls_user ';'",
"opt_mls_user : LEVEL mls_level_def RANGE mls_range_def",
"opt_mls_user :",
"initial_sid_contexts : initial_sid_context_def",
"initial_sid_contexts : initial_sid_contexts initial_sid_context_def",
"initial_sid_context_def : SID identifier security_context_def",
"opt_fs_contexts : fs_contexts",
"opt_fs_contexts :",
"fs_contexts : fs_context_def",
"fs_contexts : fs_contexts fs_context_def",
"fs_context_def : FSCON number number security_context_def security_context_def",
"net_contexts : opt_port_contexts opt_netif_contexts opt_node_contexts",
"opt_port_contexts : port_contexts",
"opt_port_contexts :",
"port_contexts : port_context_def",
"port_contexts : port_contexts port_context_def",
"port_context_def : PORTCON identifier number security_context_def",
"port_context_def : PORTCON identifier number '-' number security_context_def",
"opt_netif_contexts : netif_contexts",
"opt_netif_contexts :",
"netif_contexts : netif_context_def",
"netif_contexts : netif_contexts netif_context_def",
"netif_context_def : NETIFCON identifier security_context_def security_context_def",
"opt_node_contexts : node_contexts",
"opt_node_contexts :",
"node_contexts : node_context_def",
"node_contexts : node_contexts node_context_def",
"node_context_def : NODECON ipv4_addr_def ipv4_addr_def security_context_def",
"node_context_def : NODECON ipv6_addr ipv6_addr security_context_def",
"fs_uses : fs_use_def",
"fs_uses : fs_uses fs_use_def",
"fs_use_def : FSUSEXATTR identifier security_context_def ';'",
"fs_use_def : FSUSETASK identifier security_context_def ';'",
"fs_use_def : FSUSETRANS identifier security_context_def ';'",
"opt_genfs_contexts : genfs_contexts",
"opt_genfs_contexts :",
"genfs_contexts : genfs_context_def",
"genfs_contexts : genfs_contexts genfs_context_def",
"genfs_context_def : GENFSCON identifier path '-' identifier security_context_def",
"$$16 :",
"genfs_context_def : GENFSCON identifier path '-' '-' $$16 security_context_def",
"genfs_context_def : GENFSCON identifier path security_context_def",
"ipv4_addr_def : number '.' number '.' number '.' number",
"security_context_def : user_id ':' identifier ':' identifier opt_mls_range_def",
"opt_mls_range_def : ':' mls_range_def",
"opt_mls_range_def :",
"mls_range_def : mls_level_def '-' mls_level_def",
"mls_range_def : mls_level_def",
"mls_level_def : identifier ':' id_comma_list",
"mls_level_def : identifier",
"id_comma_list : identifier",
"id_comma_list : id_comma_list ',' identifier",
"tilde : '~'",
"asterisk : '*'",
"names : identifier",
"names : nested_id_set",
"names : asterisk",
"names : tilde identifier",
"names : tilde nested_id_set",
"$$17 :",
"names : identifier '-' $$17 identifier",
"tilde_push : tilde",
"asterisk_push : asterisk",
"names_push : identifier_push",
"names_push : '{' identifier_list_push '}'",
"names_push : asterisk_push",
"names_push : tilde_push identifier_push",
"names_push : tilde_push '{' identifier_list_push '}'",
"identifier_list_push : identifier_push",
"identifier_list_push : identifier_list_push identifier_push",
"identifier_push : IDENTIFIER",
"identifier_list : identifier",
"identifier_list : identifier_list identifier",
"nested_id_set : '{' nested_id_list '}'",
"nested_id_list : nested_id_element",
"nested_id_list : nested_id_list nested_id_element",
"nested_id_element : identifier",
"$$18 :",
"nested_id_element : '-' $$18 identifier",
"nested_id_element : nested_id_set",
"identifier : IDENTIFIER",
"user_identifier : USER_IDENTIFIER",
"user_identifier_push : USER_IDENTIFIER",
"user_identifier_list_push : user_identifier_push",
"user_identifier_list_push : identifier_list_push user_identifier_push",
"user_identifier_list_push : user_identifier_list_push identifier_push",
"user_identifier_list_push : user_identifier_list_push user_identifier_push",
"user_names_push : names_push",
"user_names_push : user_identifier_push",
"user_names_push : '{' user_identifier_list_push '}'",
"user_names_push : tilde_push user_identifier_push",
"user_names_push : tilde_push '{' user_identifier_list_push '}'",
"path : PATH",
"number : NUMBER",
"ipv6_addr : IPV6_ADDR",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 766 "policy_parse.y"
#define DEBUG 1

static int insert_separator(int push)
{
	int error;

	if (push)
		error = queue_push(id_queue, 0);
	else
		error = queue_insert(id_queue, 0);

	if (error) {
		yyerror("queue overflow");
		return -1;
	}
	return 0;
}

static int insert_id(char *id, int push)
{
	char *newid = 0;
	int error;

	newid = (char *) malloc(strlen(id) + 1);
	if (!newid) {
		yyerror("out of memory");
		return -1;
	}
	strcpy(newid, id);
	if (push)
		error = queue_push(id_queue, (queue_element_t) newid);
	else
		error = queue_insert(id_queue, (queue_element_t) newid);

	if (error) {
		yyerror("queue overflow");
		free(newid);
		return -1;
	}
	return 0;
}

/* If the identifier has a dot within it return 1, else return 0. */
static int id_has_dot(char *id)
{
        if (strchr(id, '.') >= id + 1) {
                return 1;
        }
        return 0;
}

static int define_class(void)
{
	char *id = 0;
	class_datum_t *datum = 0;
	int ret;


	if (pass == 2) {
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no class name for class definition?");
		return -1;
	}
        if (id_has_dot(id)) {
                free(id);
                yyerror("class identifiers may not contain periods");
                return -1;
        }
	datum = (class_datum_t *) malloc(sizeof(class_datum_t));
	if (!datum) {
		yyerror("out of memory");
		goto bad;
	}
	memset(datum, 0, sizeof(class_datum_t));
	datum->value = ++policydbp->p_classes.nprim;

	ret = hashtab_insert(policydbp->p_classes.table,
			     (hashtab_key_t) id, (hashtab_datum_t) datum);

	if (ret == HASHTAB_PRESENT) {
		--policydbp->p_classes.nprim;
		yyerror("duplicate class definition");
		goto bad;
	}
	if (ret == HASHTAB_OVERFLOW) {
		yyerror("hash table overflow");
		goto bad;
	}
	return 0;

      bad:
	if (id)
		free(id);
	if (datum)
		free(datum);
	return -1;
}

static int define_initial_sid(void)
{
	char *id = 0;
	ocontext_t *newc = 0, *c, *head;


	if (pass == 2) {
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no sid name for SID definition?");
		return -1;
	}
	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		goto bad;
	}
	memset(newc, 0, sizeof(ocontext_t));
	newc->u.name = id;
	context_init(&newc->context[0]);
	head = policydbp->ocontexts[OCON_ISID];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg, "duplicate initial SID %s", id);
			yyerror(errormsg);
			goto bad;
		}
	}

	if (head) {
		newc->sid[0] = head->sid[0] + 1;
	} else {
		newc->sid[0] = 1;
	}
	newc->next = head;
	policydbp->ocontexts[OCON_ISID] = newc;

	return 0;

      bad:
	if (id)
		free(id);
	if (newc)
		free(newc);
	return -1;
}

static int define_common_perms(void)
{
	char *id = 0, *perm = 0;
	common_datum_t *comdatum = 0;
	perm_datum_t *perdatum = 0;
	int ret;


	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no common name for common perm definition?");
		return -1;
	}
	comdatum = (common_datum_t *) malloc(sizeof(common_datum_t));
	if (!comdatum) {
		yyerror("out of memory");
		goto bad;
	}
	memset(comdatum, 0, sizeof(common_datum_t));
	comdatum->value = ++policydbp->p_commons.nprim;
	ret = hashtab_insert(policydbp->p_commons.table,
			 (hashtab_key_t) id, (hashtab_datum_t) comdatum);

	if (ret == HASHTAB_PRESENT) {
		yyerror("duplicate common definition");
		goto bad;
	}
	if (ret == HASHTAB_OVERFLOW) {
		yyerror("hash table overflow");
		goto bad;
	}
	if (symtab_init(&comdatum->permissions, PERM_SYMTAB_SIZE)) {
		yyerror("out of memory");
		goto bad;
	}
	while ((perm = queue_remove(id_queue))) {
		perdatum = (perm_datum_t *) malloc(sizeof(perm_datum_t));
		if (!perdatum) {
			yyerror("out of memory");
			goto bad_perm;
		}
		memset(perdatum, 0, sizeof(perm_datum_t));
		perdatum->value = ++comdatum->permissions.nprim;

		if (perdatum->value > (sizeof(access_vector_t) * 8)) {
			yyerror("too many permissions to fit in an access vector");
			goto bad_perm;
		}
		ret = hashtab_insert(comdatum->permissions.table,
				     (hashtab_key_t) perm,
				     (hashtab_datum_t) perdatum);

		if (ret == HASHTAB_PRESENT) {
			sprintf(errormsg, "duplicate permission %s in common %s",
				perm, id);
			yyerror(errormsg);
			goto bad_perm;
		}
		if (ret == HASHTAB_OVERFLOW) {
			yyerror("hash table overflow");
			goto bad_perm;
		}
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (comdatum)
		free(comdatum);
	return -1;

      bad_perm:
	if (perm)
		free(perm);
	if (perdatum)
		free(perdatum);
	return -1;
}


static int define_av_perms(int inherits)
{
	char *id;
	class_datum_t *cladatum;
	common_datum_t *comdatum;
	perm_datum_t *perdatum = 0, *perdatum2 = 0;
	int ret;


	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no tclass name for av perm definition?");
		return -1;
	}
	cladatum = (class_datum_t *) hashtab_search(policydbp->p_classes.table,
						    (hashtab_key_t) id);
	if (!cladatum) {
		sprintf(errormsg, "class %s is not defined", id);
		yyerror(errormsg);
		goto bad;
	}
	free(id);

	if (cladatum->comdatum || cladatum->permissions.nprim) {
		yyerror("duplicate access vector definition");
		return -1;
	}
	if (symtab_init(&cladatum->permissions, PERM_SYMTAB_SIZE)) {
		yyerror("out of memory");
		return -1;
	}
	if (inherits) {
		id = (char *) queue_remove(id_queue);
		if (!id) {
			yyerror("no inherits name for access vector definition?");
			return -1;
		}
		comdatum = (common_datum_t *) hashtab_search(policydbp->p_commons.table,
						     (hashtab_key_t) id);

		if (!comdatum) {
			sprintf(errormsg, "common %s is not defined", id);
			yyerror(errormsg);
			goto bad;
		}
		cladatum->comkey = id;
		cladatum->comdatum = comdatum;

		/*
		 * Class-specific permissions start with values 
		 * after the last common permission.
		 */
		cladatum->permissions.nprim += comdatum->permissions.nprim;
	}
	while ((id = queue_remove(id_queue))) {
		perdatum = (perm_datum_t *) malloc(sizeof(perm_datum_t));
		if (!perdatum) {
			yyerror("out of memory");
			goto bad;
		}
		memset(perdatum, 0, sizeof(perm_datum_t));
		perdatum->value = ++cladatum->permissions.nprim;

		if (perdatum->value > (sizeof(access_vector_t) * 8)) {
			yyerror("too many permissions to fit in an access vector");
			goto bad;
		}
		if (inherits) {
			/*
			 * Class-specific permissions and 
			 * common permissions exist in the same
			 * name space.
			 */
			perdatum2 = (perm_datum_t *) hashtab_search(cladatum->comdatum->permissions.table,
						     (hashtab_key_t) id);
			if (perdatum2) {
				sprintf(errormsg, "permission %s conflicts with an inherited permission", id);
				yyerror(errormsg);
				goto bad;
			}
		}
		ret = hashtab_insert(cladatum->permissions.table,
				     (hashtab_key_t) id,
				     (hashtab_datum_t) perdatum);

		if (ret == HASHTAB_PRESENT) {
			sprintf(errormsg, "duplicate permission %s", id);
			yyerror(errormsg);
			goto bad;
		}
		if (ret == HASHTAB_OVERFLOW) {
			yyerror("hash table overflow");
			goto bad;
		}
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (perdatum)
		free(perdatum);
	return -1;
}


static int define_sens(void)
{
	char *id;
	mls_level_t *level = 0;
	level_datum_t *datum = 0, *aliasdatum = 0;
	int ret;

	if (!mlspol) {
		yyerror("sensitivity definition in non-MLS configuration");
		return -1;
	}

	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no sensitivity name for sensitivity definition?");
		return -1;
	}
	if (id_has_dot(id)) {
		yyerror("sensitivity identifiers may not contain periods");
		goto bad;
	}
	level = (mls_level_t *) malloc(sizeof(mls_level_t));
	if (!level) {
		yyerror("out of memory");
		goto bad;
	}
	memset(level, 0, sizeof(mls_level_t));
	level->sens = 0;	/* actual value set in define_dominance */
	++policydbp->p_levels.nprim;
	ebitmap_init(&level->cat);	/* actual value set in define_level */

	datum = (level_datum_t *) malloc(sizeof(level_datum_t));
	if (!datum) {
		yyerror("out of memory");
		goto bad;
	}
	memset(datum, 0, sizeof(level_datum_t));
	datum->isalias = FALSE;
	datum->level = level;

	ret = hashtab_insert(policydbp->p_levels.table,
			     (hashtab_key_t) id, (hashtab_datum_t) datum);

	if (ret == HASHTAB_PRESENT) {
		--policydbp->p_levels.nprim;
		sprintf(errormsg, "duplicate definition for sensitivity %s", id);
		yyerror(errormsg);
		goto bad;
	}
	if (ret == HASHTAB_OVERFLOW) {
		yyerror("hash table overflow");
		goto bad;
	}

	while ((id = queue_remove(id_queue))) {
		if (id_has_dot(id)) {
			yyerror("sensitivity aliases may not contain periods");
			goto bad_alias;
		}
		aliasdatum = (level_datum_t *) malloc(sizeof(level_datum_t));
		if (!aliasdatum) {
			yyerror("out of memory");
			goto bad_alias;
		}
		memset(aliasdatum, 0, sizeof(level_datum_t));
		aliasdatum->isalias = TRUE;
		aliasdatum->level = level;

		ret = hashtab_insert(policydbp->p_levels.table,
		       (hashtab_key_t) id, (hashtab_datum_t) aliasdatum);

		if (ret == HASHTAB_PRESENT) {
			sprintf(errormsg, "duplicate definition for level %s", id);
			yyerror(errormsg);
			goto bad_alias;
		}
		if (ret == HASHTAB_OVERFLOW) {
			yyerror("hash table overflow");
			goto bad_alias;
		}
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (level)
		free(level);
	if (datum)
		free(datum);
	return -1;

      bad_alias:
	if (id)
		free(id);
	if (aliasdatum)
		free(aliasdatum);
	return -1;
}

static int define_dominance(void)
{
	level_datum_t *datum;
	int order;
	char *id;

	if (!mlspol) {
		yyerror("dominance definition in non-MLS configuration");
		return -1;
	}

	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	order = 0;
	while ((id = (char *) queue_remove(id_queue))) {
		datum = (level_datum_t *) hashtab_search(policydbp->p_levels.table,
						     (hashtab_key_t) id);
		if (!datum) {
			sprintf(errormsg, "unknown sensitivity %s used in dominance definition", id);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		if (datum->level->sens != 0) {
			sprintf(errormsg, "sensitivity %s occurs multiply in dominance definition", id);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		datum->level->sens = ++order;

		/* no need to keep sensitivity name */
		free(id);
	}

	if (order != policydbp->p_levels.nprim) {
		yyerror("all sensitivities must be specified in dominance definition");
		return -1;
	}
	return 0;
}

static int define_category(void)
{
	char *id;
	cat_datum_t *datum = 0, *aliasdatum = 0;
	int ret;

	if (!mlspol) {
		yyerror("category definition in non-MLS configuration");
		return -1;
	}

	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no category name for category definition?");
		return -1;
	}
	if (id_has_dot(id)) {
		yyerror("category identifiers may not contain periods");
		goto bad;
	}
	datum = (cat_datum_t *) malloc(sizeof(cat_datum_t));
	if (!datum) {
		yyerror("out of memory");
		goto bad;
	}
	memset(datum, 0, sizeof(cat_datum_t));
	datum->isalias = FALSE;
	datum->value = ++policydbp->p_cats.nprim;

	ret = hashtab_insert(policydbp->p_cats.table,
			     (hashtab_key_t) id, (hashtab_datum_t) datum);

	if (ret == HASHTAB_PRESENT) {
		--policydbp->p_cats.nprim;
		sprintf(errormsg, "duplicate definition for category %s", id);
		yyerror(errormsg);
		goto bad;
	}
	if (ret == HASHTAB_OVERFLOW) {
		yyerror("hash table overflow");
		goto bad;
	}

	while ((id = queue_remove(id_queue))) {
		if (id_has_dot(id)) {
			yyerror("category aliases may not contain periods");
			goto bad_alias;
		}
		aliasdatum = (cat_datum_t *) malloc(sizeof(cat_datum_t));
		if (!aliasdatum) {
			yyerror("out of memory");
			goto bad_alias;
		}
		memset(aliasdatum, 0, sizeof(cat_datum_t));
		aliasdatum->isalias = TRUE;
		aliasdatum->value = datum->value;

		ret = hashtab_insert(policydbp->p_cats.table,
		       (hashtab_key_t) id, (hashtab_datum_t) aliasdatum);

		if (ret == HASHTAB_PRESENT) {
			sprintf(errormsg, "duplicate definition for category %s", id);
			yyerror(errormsg);
			goto bad_alias;
		}
		if (ret == HASHTAB_OVERFLOW) {
			yyerror("hash table overflow");
			goto bad_alias;
		}
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (datum)
		free(datum);
	return -1;

      bad_alias:
	if (id)
		free(id);
	if (aliasdatum)
		free(aliasdatum);
	return -1;
}


static int define_level(void)
{
	char *id;
	level_datum_t *levdatum;

	if (!mlspol) {
		yyerror("level definition in non-MLS configuration");
		return -1;
	}

	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no level name for level definition?");
		return -1;
	}
	levdatum = (level_datum_t *) hashtab_search(policydbp->p_levels.table,
						    (hashtab_key_t) id);
	if (!levdatum) {
		sprintf(errormsg, "unknown sensitivity %s used in level definition", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	if (ebitmap_length(&levdatum->level->cat)) {
		sprintf(errormsg, "sensitivity %s used in multiple level definitions", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	free(id);

	while ((id = queue_remove(id_queue))) {
		cat_datum_t *cdatum;
		int range_start, range_end, i;

		if (id_has_dot(id)) {
			char *id_start = id;
			char *id_end = strchr(id, '.');

			*(id_end++) = '\0';

			cdatum = (cat_datum_t *)hashtab_search(policydbp->p_cats.table,
			                                       (hashtab_key_t)id_start);
			if (!cdatum) {
				sprintf(errormsg, "unknown category %s", id_start);
				yyerror(errormsg);
				free(id);
				return -1;
			}
			range_start = cdatum->value - 1;
			cdatum = (cat_datum_t *)hashtab_search(policydbp->p_cats.table,
			                                       (hashtab_key_t)id_end);
			if (!cdatum) {
				sprintf(errormsg, "unknown category %s", id_end);
				yyerror(errormsg);
				free(id);
				return -1;
			}
			range_end = cdatum->value - 1;

			if (range_end < range_start) {
				sprintf(errormsg, "category range is invalid");
				yyerror(errormsg);
				free(id);
				return -1;
			}
		} else {
			cdatum = (cat_datum_t *)hashtab_search(policydbp->p_cats.table,
			                                       (hashtab_key_t)id);
			range_start = range_end = cdatum->value - 1;
		}

		for (i = range_start; i <= range_end; i++) {
			if (ebitmap_set_bit(&levdatum->level->cat, i, TRUE)) {
				yyerror("out of memory");
				free(id);
				return -1;
			}
		}

		free(id);
	}

	return 0;
}

static int define_attrib(void)
{
	char *id;
	type_datum_t *attr;
	int ret;


	if (pass == 2) {
		free(queue_remove(id_queue));
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		return -1;
	}

	attr = hashtab_search(policydbp->p_types.table, id);
	if (attr) {
		sprintf(errormsg, "duplicate declaration for attribute %s\n",
			id);
		yyerror(errormsg);
		return -1;
	}

	attr = (type_datum_t *) malloc(sizeof(type_datum_t));
	if (!attr) {
		yyerror("out of memory");
		return -1;
	}
	memset(attr, 0, sizeof(type_datum_t));
	attr->isattr = TRUE;
	ret = hashtab_insert(policydbp->p_types.table,
			     id, (hashtab_datum_t) attr);
	if (ret) {
		yyerror("hash table overflow");
		return -1;
	}

	return 0;
}

static int define_typealias(void)
{
	char *id;
	type_datum_t *t, *aliasdatum;
	int ret;

	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no type name for typealias definition?");
		return -1;
	}

	t = hashtab_search(policydbp->p_types.table, id);
	if (!t || t->isattr) {
		sprintf(errormsg, "unknown type %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}

	while ((id = queue_remove(id_queue))) {
                if (id_has_dot(id)) {
                        free(id);
                        yyerror("type alias identifiers may not contain periods");
                        return -1;
                }
		aliasdatum = (type_datum_t *) malloc(sizeof(type_datum_t));
		if (!aliasdatum) {
                        free(id);
			yyerror("out of memory");
			return -1;
		}
		memset(aliasdatum, 0, sizeof(type_datum_t));
		aliasdatum->value = t->value;

		ret = hashtab_insert(policydbp->p_types.table,
				     (hashtab_key_t) id, (hashtab_datum_t) aliasdatum);

		if (ret == HASHTAB_PRESENT) {
			sprintf(errormsg, "name conflict for type alias %s", id);
			yyerror(errormsg);
			free(aliasdatum);
			free(id);
			return -1;
		}
		if (ret == HASHTAB_OVERFLOW) {
			yyerror("hash table overflow");
			free(aliasdatum);
			free(id);
			return -1;
		}
	}
	return 0;
}

static int define_typeattribute(void)
{
	char *id;
	type_datum_t *t, *attr;

	if (pass == 2) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no type name for typeattribute definition?");
		return -1;
	}

	t = hashtab_search(policydbp->p_types.table, id);
	if (!t || t->isattr) {
		sprintf(errormsg, "unknown type %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}

	while ((id = queue_remove(id_queue))) {
		attr = hashtab_search(policydbp->p_types.table, id);
		if (!attr) {
			sprintf(errormsg, "attribute %s is not declared", id);
			/* treat it as a fatal error */
			yyerror(errormsg);
			free(id);
			return -1;
		}

		if (!attr->isattr) {
			sprintf(errormsg, "%s is a type, not an attribute", id);
			yyerror(errormsg);
			free(id);
			return -1;
		}

		free(id);

		if (ebitmap_set_bit(&attr->types, (t->value - 1), TRUE)) {
			yyerror("out of memory");
			return -1;
		}
	}

	return 0;
}

static int define_type(int alias)
{
	char *id;
	type_datum_t *datum, *aliasdatum, *attr;
	int ret, newattr = 0;


	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		if (alias) {
			while ((id = queue_remove(id_queue))) 
				free(id);
		}
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no type name for type definition?");
		return -1;
	}

	datum = (type_datum_t *) malloc(sizeof(type_datum_t));
	if (!datum) {
		yyerror("out of memory");
		free(id);
		return -1;
	}
	memset(datum, 0, sizeof(type_datum_t));
	datum->primary = TRUE;
	datum->value = ++policydbp->p_types.nprim;

	ret = hashtab_insert(policydbp->p_types.table,
			     (hashtab_key_t) id, (hashtab_datum_t) datum);

	if (ret == HASHTAB_PRESENT) {
		--policydbp->p_types.nprim;
		free(datum);
		sprintf(errormsg, "name conflict for type %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	if (ret == HASHTAB_OVERFLOW) {
		yyerror("hash table overflow");
		free(datum);
		free(id);
		return -1;
	}

	if (alias) { 
		while ((id = queue_remove(id_queue))) {
			aliasdatum = (type_datum_t *) malloc(sizeof(type_datum_t));
			if (!aliasdatum) {
				yyerror("out of memory");
				return -1;
			}
			memset(aliasdatum, 0, sizeof(type_datum_t));
			aliasdatum->value = datum->value;

			ret = hashtab_insert(policydbp->p_types.table,
					     (hashtab_key_t) id, (hashtab_datum_t) aliasdatum);

			if (ret == HASHTAB_PRESENT) {
				sprintf(errormsg, "name conflict for type alias %s", id);
				yyerror(errormsg);
				free(aliasdatum);
				free(id);
				return -1;
			}
			if (ret == HASHTAB_OVERFLOW) {
				yyerror("hash table overflow");
				free(aliasdatum);
				free(id);
				return -1;
			}
		}
	}

	while ((id = queue_remove(id_queue))) {
		attr = hashtab_search(policydbp->p_types.table, id);
		if (!attr) {
			sprintf(errormsg, "attribute %s is not declared", id);
#if 1
			/* treat it as a fatal error */
			yyerror(errormsg);
			return -1;
#else
			/* Warn but automatically define the attribute.
			   Useful for quickly finding all those attributes you
			   forgot to declare. */
			yywarn(errormsg);
			attr = (type_datum_t *) malloc(sizeof(type_datum_t));
			if (!attr) {
				yyerror("out of memory");
				return -1;
			}
			memset(attr, 0, sizeof(type_datum_t));
			attr->isattr = TRUE;
			ret = hashtab_insert(policydbp->p_types.table,
					     id, (hashtab_datum_t) attr);
			if (ret) {
				yyerror("hash table overflow");
				return -1;
			}
			newattr = 1;
#endif
		} else {
			newattr = 0;
		}

		if (!attr->isattr) {
			sprintf(errormsg, "%s is a type, not an attribute", id);
			yyerror(errormsg);
			return -1;
		}

		if (!newattr)
			free(id);

		ebitmap_set_bit(&attr->types, datum->value - 1, TRUE);
	}

	return 0;
}

struct val_to_name {
	unsigned int val;
	char *name;
};

static int type_val_to_name_helper(hashtab_key_t key, hashtab_datum_t datum, void *p)
{
	type_datum_t *typdatum;
	struct val_to_name *v = p;

	typdatum = (type_datum_t *) datum;

	if (v->val == typdatum->value) {
		v->name = key;
		return 1;
	}

	return 0;
}

static char *type_val_to_name(unsigned int val) 
{
	struct val_to_name v;
	int rc;

	v.val = val;
	rc = hashtab_map(policydbp->p_types.table, 
			 type_val_to_name_helper, &v);
	if (rc)
		return v.name;
	return NULL;
}


static int set_types(ebitmap_t *set,
		     ebitmap_t *negset,
		     char *id,
		     int *add)
{
	type_datum_t *t;
	unsigned int i;

	if (strcmp(id, "*") == 0) {
		/* set all types not in negset */
		for (i = 0; i < policydbp->p_types.nprim; i++) {
			if (!ebitmap_get_bit(negset, i))
				ebitmap_set_bit(set, i, TRUE);
		}
		free(id);
		return 0;
	}

	if (strcmp(id, "~") == 0) {
		/* complement the set */
		for (i = 0; i < policydbp->p_types.nprim; i++) {
			if (ebitmap_get_bit(set, i))
				ebitmap_set_bit(set, i, FALSE);
			else 
				ebitmap_set_bit(set, i, TRUE);
		}
		free(id);
		return 0;
	}

	if (strcmp(id, "-") == 0) {
		*add = 0;
		free(id);
		return 0;
	}	

	t = hashtab_search(policydbp->p_types.table, id);
	if (!t) {
		sprintf(errormsg, "unknown type %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}

	if (t->isattr) {
		/* set or clear all types with this attribute,
		   but do not set anything explicitly cleared previously */
		for (i = ebitmap_startbit(&t->types); i < ebitmap_length(&t->types); i++) {
			if (!ebitmap_get_bit(&t->types, i)) 
				continue;		
			if (!(*add)) {
				ebitmap_set_bit(set, i, FALSE);
				ebitmap_set_bit(negset, i, TRUE);
			} else if (!ebitmap_get_bit(negset, i)) {
				ebitmap_set_bit(set, i, TRUE);
#if VERBOSE
			} else {
				char *name = type_val_to_name(i+1);
				sprintf(errormsg, "ignoring %s due to prior -%s", name, name);
				yywarn(errormsg);
#endif
			}
		}
	} else {
		/* set or clear one type, but do not set anything
		   explicitly cleared previously */	
		if (!(*add)) {
			ebitmap_set_bit(set, t->value - 1, FALSE);
			ebitmap_set_bit(negset, t->value - 1, TRUE);
		} else if (!ebitmap_get_bit(negset, t->value - 1)) {
			ebitmap_set_bit(set, t->value - 1, TRUE);
#if VERBOSE
		} else {
			sprintf(errormsg, "ignoring %s due to prior -%s", id, id);
			yywarn(errormsg);
#endif
		}
	}

	free(id);
	*add = 1;
	return 0;
}


static int define_compute_type(int which)
{
	char *id;
	avtab_key_t avkey;
	avtab_datum_t avdatum, *avdatump;
	type_datum_t *datum;
	class_datum_t *cladatum;
	ebitmap_t stypes, ttypes, tclasses, negset;
	uint32_t newtype = 0;
	int ret, add = 1;
	unsigned int i, j, k;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}

	ebitmap_init(&stypes);
	ebitmap_init(&ttypes);
	ebitmap_init(&tclasses);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&stypes, &negset, id, &add))
			return -1;
	}
	ebitmap_destroy(&negset);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&ttypes, &negset, id, &add))
			return -1;
	}
	ebitmap_destroy(&negset);

	while ((id = queue_remove(id_queue))) {
		cladatum = hashtab_search(policydbp->p_classes.table, id);
		if (!cladatum) {
			sprintf(errormsg, "unknown class %s", id);
			yyerror(errormsg);
			goto bad;
		}
		ebitmap_set_bit(&tclasses, cladatum->value - 1, TRUE);
		free(id);
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no newtype?");
		goto bad;
	}
	datum = (type_datum_t *) hashtab_search(policydbp->p_types.table,
						(hashtab_key_t) id);
	if (!datum || datum->isattr) {
		sprintf(errormsg, "unknown type %s", id);
		yyerror(errormsg);
		goto bad;
	}

	for (i = ebitmap_startbit(&stypes); i < ebitmap_length(&stypes); i++) {
		if (!ebitmap_get_bit(&stypes, i)) 
			continue;
		for (j = ebitmap_startbit(&ttypes); j < ebitmap_length(&ttypes); j++) {
			if (!ebitmap_get_bit(&ttypes, j)) 
				continue;
			for (k = ebitmap_startbit(&tclasses); k < ebitmap_length(&tclasses); k++) {
				if (!ebitmap_get_bit(&tclasses, k)) 
					continue;
				avkey.source_type = i + 1;
				avkey.target_type = j + 1;
				avkey.target_class = k + 1;
				avdatump = avtab_search(&policydbp->te_avtab, &avkey, AVTAB_TYPE);
				if (avdatump) {
					switch (which) {
					case AVTAB_TRANSITION:
						newtype = avtab_transition(avdatump);
						break;
					case AVTAB_MEMBER:
						newtype = avtab_member(avdatump);
						break;
					case AVTAB_CHANGE:
						newtype = avtab_change(avdatump);
						break;
					}
					if ( (avdatump->specified & which) &&
					     (newtype != datum->value) ) {
						sprintf(errormsg, "conflicting rule for (%s, %s:%s):  default was %s, is now %s", type_val_to_name(i+1), type_val_to_name(j+1), policydbp->p_class_val_to_name[k],
							type_val_to_name(newtype),
							type_val_to_name(datum->value));
						yywarn(errormsg);
					}
					avdatump->specified |= which;
					switch (which) {
					case AVTAB_TRANSITION:
						avtab_transition(avdatump) = datum->value;
						break;
					case AVTAB_MEMBER:
						avtab_member(avdatump) = datum->value;
						break;
					case AVTAB_CHANGE:
						avtab_change(avdatump) = datum->value;
						break;
					}
				} else {
					memset(&avdatum, 0, sizeof avdatum);
					avdatum.specified |= which;
					switch (which) {
					case AVTAB_TRANSITION:
					        avtab_transition(&avdatum) = datum->value;
						break;
					case AVTAB_MEMBER:
						avtab_member(&avdatum) = datum->value;
						break;
					case AVTAB_CHANGE:
						avtab_change(&avdatum) = datum->value;
						break;
					}
					ret = avtab_insert(&policydbp->te_avtab, &avkey, &avdatum);
					if (ret) {
						yyerror("hash table overflow");
						goto bad;
					}
				}
			}
		}
	}

	return 0;

      bad:
	return -1;
}

static cond_av_list_t *define_cond_compute_type(int which)
{
	char *id;
	cond_av_list_t *sub_list;
	avtab_key_t avkey;
	avtab_datum_t avdatum, *avdatump;
	type_datum_t *datum;
	class_datum_t *cladatum;
	ebitmap_t stypes, ttypes, tclasses, negset;
	uint32_t newtype = 0;
	int i, j, k, add = 1;

	if (pass == 1) {
		while ((id = queue_remove(id_queue)))
			free(id);
		while ((id = queue_remove(id_queue)))
			free(id);
		while ((id = queue_remove(id_queue)))
			free(id);
		id = queue_remove(id_queue);
		free(id);
		return (cond_av_list_t *)1; /* any non-NULL value */
	}
	
	ebitmap_init(&stypes);
	ebitmap_init(&ttypes);
	ebitmap_init(&tclasses);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&stypes, &negset, id, &add))
			return  COND_ERR;
	}
	ebitmap_destroy(&negset);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&ttypes, &negset, id, &add))
			return COND_ERR;
	}
	ebitmap_destroy(&negset);

	while ((id = queue_remove(id_queue))) {
		cladatum = hashtab_search(policydbp->p_classes.table, id);
		if (!cladatum) {
			sprintf(errormsg, "unknown class %s", id);
			yyerror(errormsg);
			goto bad;
		}
		ebitmap_set_bit(&tclasses, cladatum->value - 1, TRUE);
		free(id);
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no newtype?");
		goto bad;
	}
	datum = (type_datum_t *) hashtab_search(policydbp->p_types.table,
						(hashtab_key_t) id);
	if (!datum || datum->isattr) {
		sprintf(errormsg, "unknown type %s", id);
		yyerror(errormsg);
		goto bad;
	}

	/* create sub_list to be passed back and appended to true or false list */
	sub_list = (cond_av_list_t *) 0;

	for (i = ebitmap_startbit(&stypes); i < ebitmap_length(&stypes); i++) {
		if (!ebitmap_get_bit(&stypes, i)) 
			continue;
		for (j = ebitmap_startbit(&ttypes); j < ebitmap_length(&ttypes); j++) {
			if (!ebitmap_get_bit(&ttypes, j)) 
				continue;
			for (k = ebitmap_startbit(&tclasses); k < ebitmap_length(&tclasses); k++) {
				if (!ebitmap_get_bit(&tclasses, k)) 
					continue;
				avkey.source_type = i + 1;
				avkey.target_type = j + 1;
				avkey.target_class = k + 1;
				avdatump = avtab_search(&policydbp->te_avtab, &avkey, AVTAB_TYPE);
				
				/* does rule exist in base policy? */
				if ((avdatump) && (avdatump->specified & which)) {
					switch (which) {
					case AVTAB_TRANSITION:
						newtype = avtab_transition(avdatump);
						break;
					case AVTAB_MEMBER:
						newtype = avtab_member(avdatump);
						break;
					case AVTAB_CHANGE:
						newtype = avtab_change(avdatump);
						break;
					}
					if ( (newtype != datum->value) ) {
						sprintf(errormsg, "conflicting type rule for conditional "
							"(%s, %s:%s) in base: default is %s, conditional %s "
							"will be ignored", 
							type_val_to_name(i+1), 
							type_val_to_name(j+1), 
							policydbp->p_class_val_to_name[k],
							type_val_to_name(newtype),
							type_val_to_name(datum->value));
						yywarn(errormsg);
					} else {
						sprintf(errormsg, "conditional type rule (%s, %s:%s): "
							"has same default, %s, as rule in base policy; "
							"conditional %s will be ignored", 
							type_val_to_name(i+1), 
							type_val_to_name(j+1), 
							policydbp->p_class_val_to_name[k],
							type_val_to_name(newtype),
							type_val_to_name(datum->value));
						yywarn(errormsg);
					}
				}
				/* rule does not exist in base policy */
				else {
					
					memset(&avdatum, 0, sizeof avdatum);
					avdatum.specified |= which;
					switch (which) {
					case AVTAB_TRANSITION:
					        avtab_transition(&avdatum) = datum->value;
						break;
					case AVTAB_MEMBER:
						avtab_member(&avdatum) = datum->value;
						break;
					case AVTAB_CHANGE:
						avtab_change(&avdatum) = datum->value;
						break;
					}
					/* add rule to sub list */
					sub_list = cond_list_append(sub_list, &avkey, &avdatum);
					if (sub_list == COND_ERR) {
						yyerror("list overflow");
						goto bad;
					}
				}
			}
		}
	}
	
	return sub_list;

      bad:
	return COND_ERR;
}

static cond_av_list_t *cond_list_append(cond_av_list_t *sl, avtab_key_t *key, avtab_datum_t *datum) {

	cond_av_list_t  *n, *end;

	n = (cond_av_list_t *) malloc(sizeof(cond_av_list_t));
	if (!n) {
		  yyerror("out of memory");
		  return COND_ERR;
	}
	memset(n, 0, sizeof(cond_av_list_t));
	if (sl) {
		for(end=sl; end->next != NULL; end = end->next);
		end->next = n;
	}
	else sl = n;
	n->next = NULL;
	
	/* construct new node */
	n->node = (avtab_ptr_t) malloc(sizeof(struct avtab_node));
	if (!n->node) {
		yyerror("out of memory");
		return COND_ERR;
	}
	memset(n->node, 0, sizeof(struct avtab_node));
	n->node->key = *key;
	n->node->datum = *datum;
	/* the next two fields get filled in when we add to true/false list  */
	n->node->next = (avtab_ptr_t) 0;
	n->node->parse_context = (void *) 0;
	
	return(sl);
}


static int perm_name(hashtab_key_t key, hashtab_datum_t datum, void *data)
{
	struct val_to_name *v = data;
	perm_datum_t *perdatum;

	perdatum = (perm_datum_t *) datum;

	if (v->val == perdatum->value) {
		v->name = key;
		return 1;
	}

	return 0;
}


char *av_to_string(uint32_t tclass, access_vector_t av)
{
	struct val_to_name v;
	static char avbuf[1024];
	class_datum_t *cladatum;
	char *perm = NULL, *p;
	unsigned int i;
	int rc;

	cladatum = policydbp->class_val_to_struct[tclass-1];
	p = avbuf;
	for (i = 0; i < cladatum->permissions.nprim; i++) {
		if (av & (1 << i)) {
			v.val = i+1;
			rc = hashtab_map(cladatum->permissions.table,
					 perm_name, &v);
			if (!rc && cladatum->comdatum) {
				rc = hashtab_map(
					cladatum->comdatum->permissions.table,
					perm_name, &v);
			}
			if (rc)
				perm = v.name;
			if (perm) {
				sprintf(p, " %s", perm);
				p += strlen(p);
			}
		}
	}

	return avbuf;
}

static int define_bool()
{
	char *id, *name;
	cond_bool_datum_t *datum;
	int ret;


	if (pass == 2) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no identifier for bool definition?");
		return -1;
	}
        if (id_has_dot(id)) {
                free(id);
                yyerror("boolean identifiers may not contain periods");
                return -1;
        }
	name = id;

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no default value for bool definition?");
		free(name);
		return -1;
	}

	datum = (cond_bool_datum_t *) malloc(sizeof(cond_bool_datum_t));
	if (!datum) {
		yyerror("out of memory");
		free(id);
		free(name);
		return -1;
	}
	memset(datum, 0, sizeof(cond_bool_datum_t));
	datum->state = (int)(id[0] == 'T') ? 1 : 0;
	datum->value = ++policydbp->p_bools.nprim;

	ret = hashtab_insert(policydbp->p_bools.table,
			     (hashtab_key_t) name, (hashtab_datum_t) datum);

	if (ret == HASHTAB_PRESENT) {
		--policydbp->p_bools.nprim;
		free(datum);
		sprintf(errormsg, "name conflict for bool %s", id);
		yyerror(errormsg);
		free(id);
		free(name);
		return -1;
	}
	if (ret == HASHTAB_OVERFLOW) {
		yyerror("hash table overflow");
		free(datum);
		free(id);
		free(name);
		return -1;
	}
	return 0;
}

static cond_av_list_t *define_cond_pol_list( cond_av_list_t *avlist, cond_av_list_t *sl )
{
	cond_av_list_t *end;

	if (pass == 1) {
		/* return something so we get through pass 1 */
		return (cond_av_list_t *)1;
	}

	/* if we've started collecting sub lists, prepend to start of collection
	   because it's probably less iterations than appending. */
	if (!sl) return avlist;
	else if (!avlist) return sl;
	else {
		end = sl;
		while (end->next) end = end->next;
		end->next = avlist;
	} 
	return sl;
}

static int te_avtab_helper(int which, unsigned int stype, unsigned int ttype, 
			   ebitmap_t *tclasses, access_vector_t *avp)

{
	avtab_key_t avkey;
	avtab_datum_t avdatum, *avdatump;
	int ret;
	unsigned int k;

	if (which == -AVTAB_ALLOWED) {
		yyerror("neverallow should not reach this function.");
		return -1;
	}

	for (k = ebitmap_startbit(tclasses); k < ebitmap_length(tclasses); k++) {
		if (!ebitmap_get_bit(tclasses, k)) 
			continue;
		avkey.source_type = stype + 1;
		avkey.target_type = ttype + 1;
		avkey.target_class = k + 1;
		avdatump = avtab_search(&policydbp->te_avtab, &avkey, AVTAB_AV);
		if (!avdatump) {
			memset(&avdatum, 0, sizeof avdatum);
			avdatum.specified = (which > 0) ? which : -which;
			ret = avtab_insert(&policydbp->te_avtab, &avkey, &avdatum);
			if (ret) {
				yyerror("hash table overflow");
				return -1;
			}
			avdatump = avtab_search(&policydbp->te_avtab, &avkey, AVTAB_AV);
			if (!avdatump) {
				yyerror("inserted entry vanished!");
				return -1;
			}
		}

		avdatump->specified |= ((which > 0) ? which : -which);

		switch (which) {
		case AVTAB_ALLOWED:
			avtab_allowed(avdatump) |= avp[k];
			break;
		case AVTAB_AUDITALLOW:
			avtab_auditallow(avdatump) |= avp[k];
			break;
		case AVTAB_AUDITDENY:
			avtab_auditdeny(avdatump) |= avp[k];
			break;
		case -AVTAB_AUDITDENY:
			if (avtab_auditdeny(avdatump))
				avtab_auditdeny(avdatump) &= ~avp[k];
			else
				avtab_auditdeny(avdatump) = ~avp[k];
			break;
		}
	}

	return 0;
}

static  cond_av_list_t *cond_te_avtab_helper(int which, int stype, int ttype, 
			   ebitmap_t *tclasses, access_vector_t *avp )

{
	cond_av_list_t *sl;
	avtab_key_t avkey;
	avtab_datum_t avdatum;
	int  k;

	if (which == -AVTAB_ALLOWED) {
		yyerror("neverallow should not reach this function.");
		return COND_ERR;
	}

	/* create sub_list to be passed back and appended to true or false list */
	sl = (cond_av_list_t *) 0;

	for (k = ebitmap_startbit(tclasses); k < ebitmap_length(tclasses); k++) {
		if (!ebitmap_get_bit(tclasses, k)) 
			continue;
		/* build the key */
		avkey.source_type = stype + 1;
		avkey.target_type = ttype + 1;
		avkey.target_class = k + 1;
		
		/* build the datum */
		memset(&avdatum, 0, sizeof avdatum);
		avdatum.specified = (which > 0) ? which : -which;

		switch (which) {
		case AVTAB_ALLOWED:
			avtab_allowed(&avdatum) = avp[k];
			break;
		case AVTAB_AUDITALLOW:
			avtab_auditallow(&avdatum) = avp[k];
			break;
		case AVTAB_AUDITDENY:
			yyerror("AUDITDENY statements are not allowed in a conditional block; use DONTAUDIT");
			return COND_ERR;
		case -AVTAB_AUDITDENY:
			avtab_auditdeny(&avdatum) = ~avp[k];
			break;
		}

		/* add to temporary list */
		sl = cond_list_append(sl, &avkey, &avdatum);

		if (sl == COND_ERR) {
			yyerror("list overflow");
			return COND_ERR;
		}
	}

	return sl;
}

static cond_av_list_t *define_cond_te_avtab(int which)
{
	char *id;
	cond_av_list_t *sub_list, *final_list, *tail;
	class_datum_t *cladatum;
	perm_datum_t *perdatum;
	ebitmap_t stypes, ttypes, tclasses, negset;
	access_vector_t *avp;
	int i, j, hiclass, self = 0, add = 1;
	int suppress = 0;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		return (cond_av_list_t *) 1; /* any non-NULL value */
	}

	ebitmap_init(&stypes);
	ebitmap_init(&ttypes);
	ebitmap_init(&tclasses);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&stypes, &negset, id, &add))
			return COND_ERR;
	}
	ebitmap_destroy(&negset);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (strcmp(id, "self") == 0) {
			self = 1;
			continue;
		}
		if (set_types(&ttypes, &negset, id, &add))
			return COND_ERR;
	}
	ebitmap_destroy(&negset);

	hiclass = 0;
	while ((id = queue_remove(id_queue))) {
		uint32_t classvalue;

		cladatum = hashtab_search(policydbp->p_classes.table, id);
		if (!cladatum) 	{
			sprintf(errormsg, "unknown class %s used in rule", id);
			yyerror(errormsg);
			goto bad;
		}
		
		if (policyvers < POLICYDB_VERSION_NLCLASS &&
		    (cladatum->value >= SECCLASS_NETLINK_ROUTE_SOCKET &&
		     cladatum->value <= SECCLASS_NETLINK_DNRT_SOCKET)) {
			sprintf(errormsg, "remapping class %s to netlink_socket "
			        "for policy version %d", id, policyvers);
			yywarn(errormsg);
			classvalue = SECCLASS_NETLINK_SOCKET;
			suppress = 1;
		} else 
			classvalue = cladatum->value;
		
		ebitmap_set_bit(&tclasses, classvalue - 1, TRUE);	
		if (classvalue > hiclass)
			hiclass = classvalue;
		free(id);
	}

	avp = malloc(hiclass * sizeof(access_vector_t));
	if (!avp) {
		yyerror("out of memory");
		return COND_ERR;
	}
	for (i = 0; i < hiclass; i++)
		avp[i] = 0;
	while ((id = queue_remove(id_queue))) {
		for (i = ebitmap_startbit(&tclasses); i < ebitmap_length(&tclasses); i++) {
			if (!ebitmap_get_bit(&tclasses, i)) 
				continue;
			cladatum = policydbp->class_val_to_struct[i];

			if (strcmp(id, "*") == 0) {
				/* set all permissions in the class */
				avp[i] = ~0;
				continue;
			}

			if (strcmp(id, "~") == 0) {
				/* complement the set */
				if (which == -AVTAB_AUDITDENY) 
					yywarn("dontaudit rule with a ~?");
				avp[i] = ~avp[i];
				continue;
			}

			perdatum = hashtab_search(cladatum->permissions.table,
						  id);
			if (!perdatum) {
				if (cladatum->comdatum) {
					perdatum = hashtab_search(cladatum->comdatum->permissions.table,
								  id);
				}
			}
			if (!perdatum) {
				sprintf(errormsg, "permission %s is not defined for class %s", id, policydbp->p_class_val_to_name[i]);
				if (!suppress)
				  yyerror(errormsg);
				continue;
			}

			avp[i] |= (1 << (perdatum->value - 1));
		}

		free(id);
	}

	sub_list = NULL;
	tail = NULL;
	final_list = NULL;

	if (self) {
		for (i = ebitmap_startbit(&stypes); i < ebitmap_length(&stypes); i++) {
			if (!ebitmap_get_bit(&stypes, i)) 
				continue;
			if (self) {
				if ((sub_list = cond_te_avtab_helper(which, i, i, &tclasses, avp )) == COND_ERR)
					return COND_ERR;
				if (final_list) {
					tail->next = sub_list;
					while (tail->next != NULL)
						tail = tail->next;
				} else {
					final_list = sub_list;
					tail = final_list;
					while (tail->next != NULL)
						tail = tail->next;
				}
			}
		}
	}
	for (i = ebitmap_startbit(&stypes); i < ebitmap_length(&stypes); i++) {
		if (!ebitmap_get_bit(&stypes, i)) 
			continue;
		for (j = ebitmap_startbit(&ttypes); j < ebitmap_length(&ttypes); j++) {
			if (!ebitmap_get_bit(&ttypes, j)) 
				continue;
			if ((sub_list = cond_te_avtab_helper(which, i, j, &tclasses, avp)) == COND_ERR)
				return COND_ERR;
			if (final_list) {
				tail->next = sub_list;
				while (tail->next != NULL)
					tail = tail->next;
			} else {
				final_list = sub_list;
				tail = final_list;
				while (tail->next != NULL)
					tail = tail->next;
			}
		}
	}

	ebitmap_destroy(&stypes);
	ebitmap_destroy(&ttypes);
	ebitmap_destroy(&tclasses);
	free(avp);
	
	return final_list;
 bad:
	return COND_ERR;
}


static int define_te_avtab(int which)
{
	char *id;
	class_datum_t *cladatum;
	perm_datum_t *perdatum;
	ebitmap_t stypes, ttypes, tclasses, negset;
	access_vector_t *avp;
	unsigned int i, j, hiclass;
	int self = 0, add = 1;
	te_assert_t *newassert;
	int suppress = 0;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	ebitmap_init(&stypes);
	ebitmap_init(&ttypes);
	ebitmap_init(&tclasses);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&stypes, &negset, id, &add))
			return -1;
	}
	ebitmap_destroy(&negset);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (strcmp(id, "self") == 0) {
			self = 1;
			continue;
		}
		if (set_types(&ttypes, &negset, id, &add))
			return -1;
	}
	ebitmap_destroy(&negset);

	hiclass = 0;
	while ((id = queue_remove(id_queue))) {
		uint32_t classvalue;

		cladatum = hashtab_search(policydbp->p_classes.table, id);
		if (!cladatum) {
			sprintf(errormsg, "unknown class %s used in rule", id);
			yyerror(errormsg);
			goto bad;
		}
		
		if (policyvers < POLICYDB_VERSION_NLCLASS &&
		    (cladatum->value >= SECCLASS_NETLINK_ROUTE_SOCKET &&
		     cladatum->value <= SECCLASS_NETLINK_DNRT_SOCKET)) {
			sprintf(errormsg, "remapping class %s to netlink_socket "
			        "for policy version %d", id, policyvers);
			yywarn(errormsg);
			classvalue = SECCLASS_NETLINK_SOCKET;
			suppress = 1;
		} else
			classvalue = cladatum->value;
				
		ebitmap_set_bit(&tclasses, classvalue - 1, TRUE);	
		if (classvalue > hiclass)
			hiclass = classvalue;
		free(id);
	}

	avp = malloc(hiclass * sizeof(access_vector_t));
	if (!avp) {
		yyerror("out of memory");
		return -1;
	}
	for (i = 0; i < hiclass; i++)
		avp[i] = 0;

	while ((id = queue_remove(id_queue))) {
		for (i = ebitmap_startbit(&tclasses); i < ebitmap_length(&tclasses); i++) {
			if (!ebitmap_get_bit(&tclasses, i)) 
				continue;
			cladatum = policydbp->class_val_to_struct[i];

			if (strcmp(id, "*") == 0) {
				/* set all permissions in the class */
				avp[i] = ~0U;
				continue;
			}

			if (strcmp(id, "~") == 0) {
				/* complement the set */
				if (which == -AVTAB_AUDITDENY) 
					yywarn("dontaudit rule with a ~?");
				avp[i] = ~avp[i];
				continue;
			}

			perdatum = hashtab_search(cladatum->permissions.table,
						  id);
			if (!perdatum) {
				if (cladatum->comdatum) {
					perdatum = hashtab_search(cladatum->comdatum->permissions.table,
								  id);
				}
			}
			if (!perdatum) {
				sprintf(errormsg, "permission %s is not defined for class %s", id, policydbp->p_class_val_to_name[i]);
				if (!suppress)
				  yyerror(errormsg);
				continue;
			}

			avp[i] |= (1 << (perdatum->value - 1));
		}

		free(id);
	}

	if (which == -AVTAB_ALLOWED) {
		newassert = malloc(sizeof(te_assert_t));
		if (!newassert) {
			yyerror("out of memory");
			return -1;
		}
		memset(newassert, 0, sizeof(te_assert_t));
		newassert->stypes = stypes;
		newassert->ttypes = ttypes;
		newassert->tclasses = tclasses;
		newassert->self = self;
		newassert->avp = avp;
		newassert->line = policydb_lineno;
		newassert->next = te_assertions;
		te_assertions = newassert;
		return 0;
	}

	for (i = ebitmap_startbit(&stypes); i < ebitmap_length(&stypes); i++) {
		if (!ebitmap_get_bit(&stypes, i)) 
			continue;
		if (self) {
			if (te_avtab_helper(which, i, i, &tclasses, avp))
				return -1;
		}
		for (j = ebitmap_startbit(&ttypes); j < ebitmap_length(&ttypes); j++) {
			if (!ebitmap_get_bit(&ttypes, j)) 
				continue;
			if (te_avtab_helper(which, i, j, &tclasses, avp))
				return -1;
		}
	}

	ebitmap_destroy(&stypes);
	ebitmap_destroy(&ttypes);
	ebitmap_destroy(&tclasses);
	free(avp);

	return 0;
 bad:
	return -1;
}


static int role_val_to_name_helper(hashtab_key_t key, hashtab_datum_t datum, void *p)
{
	struct val_to_name *v = p;
	role_datum_t *roldatum;

	roldatum = (role_datum_t *) datum;

	if (v->val == roldatum->value) {
		v->name = key;
		return 1;
	}

	return 0;
}


static char *role_val_to_name(unsigned int val) 
{
	struct val_to_name v;
	int rc;

	v.val = val;
	rc = hashtab_map(policydbp->p_roles.table, 
			 role_val_to_name_helper, &v);
	if (rc)
		return v.name;
	return NULL;
}

static int define_role_types(void)
{
	role_datum_t *role;
	char *role_id, *id;
	int ret, add = 1;
	ebitmap_t negset;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	role_id = queue_remove(id_queue);

	role = (role_datum_t *) hashtab_search(policydbp->p_roles.table,
					       role_id);
	if (!role) {
		role = (role_datum_t *) malloc(sizeof(role_datum_t));
		if (!role) {
			yyerror("out of memory");
			free(role_id);
			return -1;
		}
		memset(role, 0, sizeof(role_datum_t));
		role->value = ++policydbp->p_roles.nprim;
		ebitmap_set_bit(&role->dominates, role->value-1, TRUE);
		ret = hashtab_insert(policydbp->p_roles.table,
				     (hashtab_key_t) role_id, (hashtab_datum_t) role);

		if (ret) {
			yyerror("hash table overflow");
			free(role);
			free(role_id);
			return -1;
		}
	} else
		free(role_id);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&role->types, &negset, id, &add))
			return -1;
	}
	ebitmap_destroy(&negset);

	return 0;
}


static role_datum_t *
 merge_roles_dom(role_datum_t * r1, role_datum_t * r2)
{
	role_datum_t *new;

	if (pass == 1) {
		return (role_datum_t *)1; /* any non-NULL value */
	}

	new = malloc(sizeof(role_datum_t));
	if (!new) {
		yyerror("out of memory");
		return NULL;
	}
	memset(new, 0, sizeof(role_datum_t));
	new->value = 0;		/* temporary role */
	if (ebitmap_or(&new->dominates, &r1->dominates, &r2->dominates)) {
		yyerror("out of memory");
		return NULL;
	}
	if (ebitmap_or(&new->types, &r1->types, &r2->types)) {
		yyerror("out of memory");
		return NULL;
	}
	if (!r1->value) {
		/* free intermediate result */
		ebitmap_destroy(&r1->types);
		ebitmap_destroy(&r1->dominates);
		free(r1);
	}
	if (!r2->value) {
		/* free intermediate result */
		yyerror("right hand role is temporary?");
		ebitmap_destroy(&r2->types);
		ebitmap_destroy(&r2->dominates);
		free(r2);
	}
	return new;
}

/* This function eliminates the ordering dependency of role dominance rule */
static int dominate_role_recheck(hashtab_key_t key, hashtab_datum_t datum, void *arg)
{
	role_datum_t *rdp = (role_datum_t *) arg;
	role_datum_t *rdatum = (role_datum_t *) datum;
	int i;

	/* Don't bother to process against self role */
	if (rdatum->value == rdp->value)
		return 0;

	/* If a dominating role found */
	if (ebitmap_get_bit(&(rdatum->dominates), rdp->value - 1))
	{
		/* raise types and dominates from dominated role */
		for (i = ebitmap_startbit(&rdp->dominates); 
			i < ebitmap_length(&rdp->dominates); i++) 
		{
			if (ebitmap_get_bit(&rdp->dominates, i))
				ebitmap_set_bit(&rdatum->dominates, i, TRUE);
		}
		for (i = ebitmap_startbit(&rdp->types); 
			i < ebitmap_length(&rdp->types); i++)	
		{
			if (ebitmap_get_bit(&rdp->types, i))
				ebitmap_set_bit(&rdatum->types, i, TRUE);
		}		
	}

	/* go through all the roles */
	return 0;
}

static role_datum_t *
 define_role_dom(role_datum_t * r)
{
	role_datum_t *role;
	char *role_id;
	unsigned int i;
	int ret;

	if (pass == 1) {
		role_id = queue_remove(id_queue);
		free(role_id);
		return (role_datum_t *)1; /* any non-NULL value */
	}

	role_id = queue_remove(id_queue);
	role = (role_datum_t *) hashtab_search(policydbp->p_roles.table,
					       role_id);
	if (!role) {
		role = (role_datum_t *) malloc(sizeof(role_datum_t));
		if (!role) {
			yyerror("out of memory");
			free(role_id);
			return NULL;
		}
		memset(role, 0, sizeof(role_datum_t));
		role->value = ++policydbp->p_roles.nprim;
		ebitmap_set_bit(&role->dominates, role->value-1, TRUE);
		ret = hashtab_insert(policydbp->p_roles.table,
				     (hashtab_key_t) role_id, (hashtab_datum_t) role);

		if (ret) {
			yyerror("hash table overflow");
			free(role);
			free(role_id);
			return NULL;
		}
	}
	if (r) {
		for (i = ebitmap_startbit(&r->dominates); i < ebitmap_length(&r->dominates); i++) {
			if (ebitmap_get_bit(&r->dominates, i))
				ebitmap_set_bit(&role->dominates, i, TRUE);
		}
		for (i = ebitmap_startbit(&r->types); i < ebitmap_length(&r->types); i++)	{
			if (ebitmap_get_bit(&r->types, i))
				ebitmap_set_bit(&role->types, i, TRUE);
		}
		if (!r->value) {
			/* free intermediate result */
			ebitmap_destroy(&r->types);
			ebitmap_destroy(&r->dominates);
			free(r);
		}
		/*
		 * Now go through all the roles and escalate this role's
		 * dominates and types if a role dominates this role.
		 */
		hashtab_map(policydbp->p_roles.table,
						dominate_role_recheck, role);
	}
	return role;
}


static int set_roles(ebitmap_t *set,
		     char *id)
{
	role_datum_t *r;
	unsigned int i;

	if (strcmp(id, "*") == 0) {
		/* set all roles */
		for (i = 0; i < policydbp->p_roles.nprim; i++) 
			ebitmap_set_bit(set, i, TRUE);
		free(id);
		return 0;
	}

	if (strcmp(id, "~") == 0) {
		/* complement the set */
		for (i = 0; i < policydbp->p_roles.nprim; i++) {
			if (ebitmap_get_bit(set, i))
				ebitmap_set_bit(set, i, FALSE);
			else 
				ebitmap_set_bit(set, i, TRUE);
		}
		free(id);
		return 0;
	}

	r = hashtab_search(policydbp->p_roles.table, id);
	if (!r) {
		sprintf(errormsg, "unknown role %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}

	/* set one role */
	ebitmap_set_bit(set, r->value - 1, TRUE);
	free(id);
	return 0;
}


static int define_role_trans(void)
{
	char *id;
	role_datum_t *role;
	ebitmap_t roles, types, negset;
	struct role_trans *tr = 0;
	unsigned int i, j;
	int add = 1;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}

	ebitmap_init(&roles);
	ebitmap_init(&types);

	while ((id = queue_remove(id_queue))) {
		if (set_roles(&roles, id))
			return -1;
	}

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&types, &negset, id, &add))
			return -1;
	}
	ebitmap_destroy(&negset);

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no new role in transition definition?");
		goto bad;
	}
	role = hashtab_search(policydbp->p_roles.table, id);
	if (!role) {
		sprintf(errormsg, "unknown role %s used in transition definition", id);
		yyerror(errormsg);
		goto bad;
	}

	for (i = ebitmap_startbit(&roles); i < ebitmap_length(&roles); i++) {
		if (!ebitmap_get_bit(&roles, i)) 
			continue;
		for (j = ebitmap_startbit(&types); j < ebitmap_length(&types); j++) {
			if (!ebitmap_get_bit(&types, j)) 
				continue;

			for (tr = policydbp->role_tr; tr; tr = tr->next) {
				if (tr->role == (i+1) && tr->type == (j+1)) {
					sprintf(errormsg, "duplicate role transition defined for (%s,%s)", 
						role_val_to_name(i+1), type_val_to_name(j+1));
					yyerror(errormsg);
					goto bad;
				}
			}

			tr = malloc(sizeof(struct role_trans));
			if (!tr) {
				yyerror("out of memory");
				return -1;
			}
			memset(tr, 0, sizeof(struct role_trans));
			tr->role = i+1;
			tr->type = j+1;
			tr->new_role = role->value;
			tr->next = policydbp->role_tr;
			policydbp->role_tr = tr;
		}
	}

	return 0;

 bad:
	return -1;
}


static int define_role_allow(void)
{
	char *id;
	ebitmap_t roles, new_roles;
	struct role_allow *ra = 0;
	unsigned int i, j;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	ebitmap_init(&roles);
	ebitmap_init(&new_roles);

	while ((id = queue_remove(id_queue))) {
		if (set_roles(&roles, id))
			return -1;
	}


	while ((id = queue_remove(id_queue))) {
		if (set_roles(&new_roles, id))
			return -1;
	}

	for (i = ebitmap_startbit(&roles); i < ebitmap_length(&roles); i++) {
		if (!ebitmap_get_bit(&roles, i)) 
			continue;
		for (j = ebitmap_startbit(&new_roles); j < ebitmap_length(&new_roles); j++) {
			if (!ebitmap_get_bit(&new_roles, j)) 
				continue;

			for (ra = policydbp->role_allow; ra; ra = ra->next) {
				if (ra->role == (i+1) && ra->new_role == (j+1))
					break;
			}

			if (ra) 
				continue;

			ra = malloc(sizeof(struct role_allow));
			if (!ra) {
				yyerror("out of memory");
				return -1;
			}
			memset(ra, 0, sizeof(struct role_allow));
			ra->role = i+1;
			ra->new_role = j+1;
			ra->next = policydbp->role_allow;
			policydbp->role_allow = ra;
		}
	}

	return 0;
}


static int define_constraint(constraint_expr_t * expr)
{
	struct constraint_node *node;
	char *id;
	class_datum_t *cladatum;
	perm_datum_t *perdatum;
	ebitmap_t classmap;
	constraint_expr_t *e;
	unsigned int i;
	int depth;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	depth = -1;
	for (e = expr; e; e = e->next) {
		switch (e->expr_type) {
		case CEXPR_NOT:
			if (depth < 0) {
				yyerror("illegal constraint expression");
				return -1;
			}
			break;
		case CEXPR_AND:
		case CEXPR_OR:
			if (depth < 1) {
				yyerror("illegal constraint expression");
				return -1;
			}
			depth--;
			break;
		case CEXPR_ATTR:
		case CEXPR_NAMES:
			if (e->attr & CEXPR_XTARGET) {
				yyerror("illegal constraint expression");
				return -1; /* only for validatetrans rules */
			}
			if (depth == (CEXPR_MAXDEPTH-1)) {
				yyerror("constraint expression is too deep");
				return -1;
			}
			depth++;
			break;
		default:
			yyerror("illegal constraint expression");
			return -1;
		}
	}
	if (depth != 0) {
		yyerror("illegal constraint expression");
		return -1;
	}

	ebitmap_init(&classmap);
	while ((id = queue_remove(id_queue))) {
		cladatum = (class_datum_t *) hashtab_search(policydbp->p_classes.table,
						     (hashtab_key_t) id);
		if (!cladatum) {
			sprintf(errormsg, "class %s is not defined", id);
			ebitmap_destroy(&classmap);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		if (ebitmap_set_bit(&classmap, cladatum->value - 1, TRUE)) {
			yyerror("out of memory");
			ebitmap_destroy(&classmap);
			free(id);
			return -1;
		}
		node = malloc(sizeof(struct constraint_node));
		if (!node) {
			yyerror("out of memory");
			return -1;
		}
		memset(node, 0, sizeof(constraint_node_t));
		node->expr = expr;
		node->permissions = 0;

		node->next = cladatum->constraints;
		cladatum->constraints = node;

		free(id);
	}

	while ((id = queue_remove(id_queue))) {
		for (i = ebitmap_startbit(&classmap); i < ebitmap_length(&classmap); i++) {
			if (ebitmap_get_bit(&classmap, i)) {
				cladatum = policydbp->class_val_to_struct[i];
				node = cladatum->constraints;

				perdatum = (perm_datum_t *) hashtab_search(cladatum->permissions.table,
						     (hashtab_key_t) id);
				if (!perdatum) {
					if (cladatum->comdatum) {
						perdatum = (perm_datum_t *) hashtab_search(cladatum->comdatum->permissions.table,
						     (hashtab_key_t) id);
					}
					if (!perdatum) {
						sprintf(errormsg, "permission %s is not defined", id);
						yyerror(errormsg);
						free(id);
						ebitmap_destroy(&classmap);
						return -1;
					}
				}
				node->permissions |= (1 << (perdatum->value - 1));
			}
		}
		free(id);
	}

	ebitmap_destroy(&classmap);

	return 0;
}

static int define_validatetrans(constraint_expr_t *expr)
{
	struct constraint_node *node;
	char *id;
	class_datum_t *cladatum;
	ebitmap_t classmap;
	constraint_expr_t *e;
	int depth;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	depth = -1;
	for (e = expr; e; e = e->next) {
		switch (e->expr_type) {
		case CEXPR_NOT:
			if (depth < 0) {
				yyerror("illegal validatetrans expression");
				return -1;
			}
			break;
		case CEXPR_AND:
		case CEXPR_OR:
			if (depth < 1) {
				yyerror("illegal validatetrans expression");
				return -1;
			}
			depth--;
			break;
		case CEXPR_ATTR:
		case CEXPR_NAMES:
			if (depth == (CEXPR_MAXDEPTH - 1)) {
				yyerror("validatetrans expression is too deep");
				return -1;
			}
			depth++;
			break;
		default:
			yyerror("illegal validatetrans expression");
			return -1;
		}
	}
	if (depth != 0) {
		yyerror("illegal validatetrans expression");
		return -1;
	}

	ebitmap_init(&classmap);
	while ((id = queue_remove(id_queue))) {
		cladatum = (class_datum_t *)hashtab_search(policydbp->p_classes.table, (hashtab_key_t)id);
		if (!cladatum) {
			sprintf(errormsg, "class %s is not defined", id);
			ebitmap_destroy(&classmap);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		if (ebitmap_set_bit(&classmap, (cladatum->value - 1), TRUE)) {
			yyerror("out of memory");
			ebitmap_destroy(&classmap);
			free(id);
			return -1;
		}

		node = malloc(sizeof(struct constraint_node));
		if (!node) {
			yyerror("out of memory");
			return -1;
		}
		memset(node, 0, sizeof(constraint_node_t));
		node->expr = expr;
		node->permissions = 0;

		node->next = cladatum->validatetrans;
		cladatum->validatetrans = node;

		free(id);
	}

	ebitmap_destroy(&classmap);

	return 0;
}


static uintptr_t
 define_cexpr(uint32_t expr_type, uintptr_t arg1, uintptr_t arg2)
{
	struct constraint_expr *expr, *e1 = NULL, *e2;
	user_datum_t *user;
	role_datum_t *role;
	ebitmap_t negset;
	char *id;
	uint32_t val;
	int add = 1;

	if (pass == 1) {
		if (expr_type == CEXPR_NAMES) {
			while ((id = queue_remove(id_queue))) 
				free(id);
		}
		return 1; /* any non-NULL value */
	}

	expr = malloc(sizeof(struct constraint_expr));
	if (!expr) {
		yyerror("out of memory");
		return 0;
	}
	memset(expr, 0, sizeof(constraint_expr_t));
	expr->expr_type = expr_type;

	switch (expr_type) {
	case CEXPR_NOT:
		e1 = NULL;
		e2 = (struct constraint_expr *) arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal constraint expression");
			free(expr);
			return 0;
		}
		e1->next = expr;
		return arg1;
	case CEXPR_AND:
	case CEXPR_OR:
		e1 = NULL;
		e2 = (struct constraint_expr *) arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal constraint expression");
			free(expr);
			return 0;
		}
		e1->next = (struct constraint_expr *) arg2;

		e1 = NULL;
		e2 = (struct constraint_expr *) arg2;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal constraint expression");
			free(expr);
			return 0;
		}
		e1->next = expr;
		return arg1;
	case CEXPR_ATTR:
		expr->attr = arg1;
		expr->op = arg2;
		return (uintptr_t)expr;
	case CEXPR_NAMES:
		expr->attr = arg1;
		expr->op = arg2;
		ebitmap_init(&negset);
		while ((id = (char *) queue_remove(id_queue))) {
			if (expr->attr & CEXPR_USER) {
				user = (user_datum_t *) hashtab_search(policydbp->p_users.table,
								       (hashtab_key_t) id);
				if (!user) {
					sprintf(errormsg, "unknown user %s", id);
					yyerror(errormsg);
					free(expr);
					return 0;
				}
				val = user->value;
			} else if (expr->attr & CEXPR_ROLE) {
				role = (role_datum_t *) hashtab_search(policydbp->p_roles.table,
								       (hashtab_key_t) id);
				if (!role) {
					sprintf(errormsg, "unknown role %s", id);
					yyerror(errormsg);
					free(expr);
					return 0;
				}
				val = role->value;
			} else if (expr->attr & CEXPR_TYPE) {
				if (set_types(&expr->names, &negset, id, &add)) {
					free(expr);
					return 0;
				}
				continue;
			} else {
				yyerror("invalid constraint expression");
				free(expr);
				return 0;
			}
			if (ebitmap_set_bit(&expr->names, val - 1, TRUE)) {
				yyerror("out of memory");
				ebitmap_destroy(&expr->names);
				free(expr);
				return 0;
			}
			free(id);
		}
		ebitmap_destroy(&negset);
		return (uintptr_t)expr;
	default:
		yyerror("invalid constraint expression");
		free(expr);
		return 0;
	}

	yyerror("invalid constraint expression");
	free(expr);
	return 0;
}

static int define_conditional(cond_expr_t *expr, cond_av_list_t *t, cond_av_list_t *f )
{
	cond_expr_t *e;
	cond_node_t *cn, tmp, *cn_new;
	int depth;


	/* expression cannot be NULL */
	if ( !expr) {
		yyerror("illegal conditional expression");
		return -1;
	}
	if (!t) {
		if (!f) {
			yyerror("must have at least one rule");
			return -1;
		}
		/* Invert */
		t = f;
		f = 0;
		expr = define_cond_expr(COND_NOT, expr, 0);
		if (!expr) {
			yyerror("unable to invert");
			return -1;
		}
	}

	/* verify expression */
	depth = -1;
	for (e = expr; e; e = e->next) {
		switch (e->expr_type) {
		case COND_NOT:
			if (depth < 0) {
				yyerror("illegal conditional expression; Bad NOT");
				return -1;
			}
			break;
		case COND_AND:
		case COND_OR:
		case COND_XOR:
		case COND_EQ:
		case COND_NEQ:
			if (depth < 1) {
				yyerror("illegal conditional expression; Bad binary op");
				return -1;
			}
			depth--;
			break;
		case COND_BOOL:
			if (depth == (COND_EXPR_MAXDEPTH-1)) {
				yyerror("conditional expression is like totally too deep");
				return -1;
			}
			depth++;
			break;
		default:
			yyerror("illegal conditional expression");
			return -1;
		}
	}
	if (depth != 0) {
		yyerror("illegal conditional expression");
		return -1;
	}

        /*  use tmp conditional node to partially build new node */
	cn = &tmp;
	cn->expr = expr;
	cn->true_list = t;
	cn->false_list = f;
      
	/* normalize/precompute expression */
	if (cond_normalize_expr(policydbp, cn) < 0) {
		yyerror("problem normalizing conditional expression");
		return -1;
	}

	/* get the existing conditional node, or a new one*/
	cn_new = cond_node_search(policydbp, cn);
	if(cn_new) {
		cond_reduce_insert_list (cn->true_list, &cn_new->true_list, &cn_new->false_list, cn_new->cur_state);
		cond_reduce_insert_list (cn->false_list, &cn_new->false_list, &cn_new->true_list, !cn_new->cur_state);
	} else { 
		yyerror("could not get a conditional node");
		return -1;
	}


	return 0;
}


/*  Set the ENABLE bit and parse_context for each rule and check rules to see if they already exist.
 * Insert rules into the conditional db when appropriate.
 *  
 * new - list of rules to potentially add/insert
 * active - list to add rule to, and address to use as parse_context
 * inactive - opposite rule list in same conditional
 * state - whether rules in new are on or off by default.
 *
 * There are 4 possible conditions for a TYPE_* rule.  Allow rules are always inserted or
 * OR'd with existing allow rules on the same side of the same conditional.
 *
 * 1) Not present anywhere -> add it
 * 2) Already in cond, same side -> warn, replace default in prev rule, delete this rule
 * 3) Just added to opp side -> search again (we may still add this rule)
 * 4) In another conditional (either side) -> warn, delete this rule
 */
static void cond_reduce_insert_list(cond_av_list_t *new, cond_av_list_t **active, cond_av_list_t **inactive, int state)
{
	int add_rule = 1;
	cond_av_list_t *c, *top;
	avtab_ptr_t dup;
	uint32_t old_data = 0, new_data = 0;

	top = c = new; 
	/* loop through all the rules in the list */
	while(c) {

                /* is conditional rule a TYPE_* rule that's already in a conditional? */
                /* [note that we checked to see if it's in the base when we parsed the rule] */
		if ((c->node->datum.specified & AVTAB_TYPE) &&
		    ((dup = avtab_search_node(&policydbp->te_cond_avtab, &c->node->key, c->node->datum.specified & AVTAB_TYPE)) != NULL) ){
			do {
				/* is the rule we found in the current rule list or the equivalent */
				if (dup->parse_context == active) {
					/* change original default */
					switch(c->node->datum.specified & AVTAB_TYPE) {
					case AVTAB_TRANSITION:
						old_data = avtab_transition(&dup->datum);
						new_data = avtab_transition(&c->node->datum);
						avtab_transition(&dup->datum) = new_data;
						break;
					case AVTAB_MEMBER:
						old_data = avtab_member(&dup->datum);
						new_data = avtab_member(&c->node->datum);
						avtab_member(&dup->datum) = new_data;
						break;
					case AVTAB_CHANGE:
						old_data = avtab_change(&dup->datum);
						new_data = avtab_change(&c->node->datum);
						avtab_change(&dup->datum) = new_data;
						break;
					}
					sprintf(errormsg, "duplicate type rule on same side of conditional for (%s, %s:%s); overwrote original default %s with %s",
						type_val_to_name(c->node->key.source_type), 
						type_val_to_name(c->node->key.target_type), 
						policydbp->p_class_val_to_name[c->node->key.target_class],
						type_val_to_name(old_data),
						type_val_to_name(new_data));					
					yywarn(errormsg);
					add_rule = 0;
					break;
				}
				/* if the rule we found is in the opposite rule list that's OK*/
				if (dup->parse_context == inactive) {
					continue;
				} else {
					/* the rule we found must be in another conditional */
					sprintf(errormsg, "discarding conflicting conditional type rule for (%s, %s:%s); may only be in one conditional",
						type_val_to_name(c->node->key.source_type), 
						type_val_to_name(c->node->key.target_type), 
						policydbp->p_class_val_to_name[c->node->key.target_class]);
					yywarn(errormsg);
					add_rule = 0;
					break;
				}
			} while ( (dup = avtab_search_node_next(dup, c->node->datum.specified & AVTAB_TYPE)) != NULL);

		} /* end dealing with TYPE_* rules */
		else if ( (c->node->datum.specified & AVTAB_AV ) &&
		     ((dup = avtab_search_node(&policydbp->te_cond_avtab, &c->node->key, c->node->datum.specified & AVTAB_AV)) != NULL) ){
			do {
				/* we only care if the same AV rule is on the same side of the same conditional */
				if (dup->parse_context == active) {
					/* add to original */
					switch(c->node->datum.specified & AVTAB_AV) {
					case AVTAB_ALLOWED:
						new_data = avtab_allowed(&c->node->datum);
						avtab_allowed(&dup->datum) |= new_data;
						break;
					case AVTAB_AUDITALLOW:
						new_data = avtab_auditallow(&c->node->datum);
						avtab_auditallow(&dup->datum) |= new_data;
						break;
					case AVTAB_AUDITDENY:
						new_data = avtab_auditdeny(&c->node->datum);
						/* Since a '0' in an auditdeny mask represents a 
						 * permission we do NOT want to audit (dontaudit), we use
						 * the '&' operand to ensure that all '0's in the mask
						 * are retained (much unlike the allow and auditallow cases).
						 */
						avtab_auditdeny(&dup->datum) &= new_data;
						break;
					}
					add_rule = 0;
					break;
				}
			} while ( (dup = avtab_search_node_next(dup, c->node->datum.specified & AVTAB_AV)) != NULL);
		} /* end dealing with ALLOW rules */

		top = c->next;
		/* Either insert the rule into the policy and active list, or discard the rule */
		if (add_rule) {
			c->node = avtab_insert_with_parse_context(&policydbp->te_cond_avtab, 
								  &c->node->key,
								  &c->node->datum,
								  active);
			/* set whether the rule is enabled/disabled */
			if (state) {
				c->node->datum.specified |= AVTAB_ENABLED;
			} else {
				c->node->datum.specified &= ~AVTAB_ENABLED;
			}

			/* prepend new rule to active list */
 			c->next = *active; 
 			*active = c; 
		} else {
			/* discard rule */
			free(c->node);
			free(c);
			
			add_rule = 1;
		}
                /* next rule */
		c = top;
		
	} /* while */
}

static cond_expr_t *
 define_cond_expr(uint32_t expr_type, void* arg1, void* arg2)
{
	struct cond_expr *expr, *e1 = NULL, *e2;
	cond_bool_datum_t *bool_var;
	char *id;

	/* expressions are handled in the second pass */
	if (pass == 1) {
		if (expr_type == COND_BOOL) {
			while ((id = queue_remove(id_queue))) {
				free(id);
			}
		}
		return (cond_expr_t *)1; /* any non-NULL value */
	}

	/* create a new expression struct */
	expr = malloc(sizeof(struct cond_expr));
	if (!expr) {
		yyerror("out of memory");
		return NULL;
	}
	memset(expr, 0, sizeof(cond_expr_t));
	expr->expr_type = expr_type;

	/* create the type asked for */
	switch (expr_type) {
	case COND_NOT:
		e1 = NULL;
		e2 = (struct cond_expr *) arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal conditional NOT expression");
			free(expr);
			return NULL;
		}
		e1->next = expr;
		return (struct cond_expr *) arg1;
	case COND_AND:
	case COND_OR:
	case COND_XOR:
	case COND_EQ:
	case COND_NEQ:
		e1 = NULL;
		e2 = (struct cond_expr *) arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal left side of conditional binary op expression");
			free(expr);
			return NULL;
		}
		e1->next = (struct cond_expr *) arg2;

		e1 = NULL;
		e2 = (struct cond_expr *) arg2;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal right side of conditional binary op expression");
			free(expr);
			return NULL ;
		}
		e1->next = expr;
		return (struct cond_expr *) arg1;
	case COND_BOOL:
		id = (char *) queue_remove(id_queue) ;
		if (!id) {
			yyerror("bad conditional; expected boolean id");
			free(id);
			free(expr);
			return NULL;
		}
		bool_var = (cond_bool_datum_t *) hashtab_search(policydbp->p_bools.table,
								(hashtab_key_t) id);
		if (!bool_var) {
			sprintf(errormsg, "unknown boolean %s in conditional expression", id);
			yyerror(errormsg);
			free(expr);
			free(id);
			return NULL ;
		}
		expr->bool = bool_var->value;
		free(id);
		return expr;
	default:
		yyerror("illegal conditional expression");
		return NULL;
	}
}


static int set_user_roles(ebitmap_t *set,
			  char *id)
{
	role_datum_t *r;
	unsigned int i;

	if (strcmp(id, "*") == 0) {
		/* set all roles */
		for (i = 0; i < policydbp->p_roles.nprim; i++) 
			ebitmap_set_bit(set, i, TRUE);
		free(id);
		return 0;
	}

	if (strcmp(id, "~") == 0) {
		/* complement the set */
		for (i = 0; i < policydbp->p_roles.nprim; i++) {
			if (ebitmap_get_bit(set, i))
				ebitmap_set_bit(set, i, FALSE);
			else 
				ebitmap_set_bit(set, i, TRUE);
		}
		free(id);
		return 0;
	}

	r = hashtab_search(policydbp->p_roles.table, id);
	if (!r) {
		sprintf(errormsg, "unknown role %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}

	/* set the role and every role it dominates */
	for (i = ebitmap_startbit(&r->dominates); i < ebitmap_length(&r->dominates); i++) {
		if (ebitmap_get_bit(&r->dominates, i))
			ebitmap_set_bit(set, i, TRUE);
	}
	free(id);
	return 0;
}


static int
parse_categories(char *id, level_datum_t *levdatum, ebitmap_t *cats)
{
	cat_datum_t *cdatum;
	int range_start, range_end, i;

	if (id_has_dot(id)) {
		char *id_start = id;
		char *id_end = strchr(id, '.');

		*(id_end++) = '\0';

		cdatum = (cat_datum_t *)hashtab_search(policydbp->p_cats.table,
		                                       (hashtab_key_t)id_start);
		if (!cdatum) {
			sprintf(errormsg, "unknown category %s", id_start);
			yyerror(errormsg);
			return -1;
		}
		range_start = cdatum->value - 1;
		cdatum = (cat_datum_t *)hashtab_search(policydbp->p_cats.table,
		                                       (hashtab_key_t)id_end);
		if (!cdatum) {
			sprintf(errormsg, "unknown category %s", id_end);
			yyerror(errormsg);
			return -1;
		}
		range_end = cdatum->value - 1;

		if (range_end < range_start) {
			sprintf(errormsg, "category range is invalid");
			yyerror(errormsg);
			return -1;
		}
	} else {
		cdatum = (cat_datum_t *)hashtab_search(policydbp->p_cats.table,
		                                       (hashtab_key_t)id);
		range_start = range_end = cdatum->value - 1;
	}

	for (i = range_start; i <= range_end; i++) {
		if (!ebitmap_get_bit(&levdatum->level->cat, i)) {
			uint32_t level_value = levdatum->level->sens - 1;
			policydb_index_others(policydbp, 0);
			sprintf(errormsg, "category %s can not be associated "
			        "with level %s",
			        policydbp->p_cat_val_to_name[i],
			        policydbp->p_sens_val_to_name[level_value]);
			yyerror(errormsg);
			return -1;
		}
		if (ebitmap_set_bit(cats, i, TRUE)) {
			yyerror("out of memory");
			return -1;
		}
	}

	return 0;
}


static int define_user(void)
{
	char *id;
	user_datum_t *usrdatum;
	int ret;
	level_datum_t *levdatum;
	int l;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		if (mlspol) {
			while ((id = queue_remove(id_queue))) 
				free(id);
			id = queue_remove(id_queue); free(id);
			for (l = 0; l < 2; l++) {
				while ((id = queue_remove(id_queue))) { 
					free(id);
				}
				id = queue_remove(id_queue);
				if (!id)
					break;
				free(id);
			}
		}
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no user name for user definition?");
		return -1;
	}
	usrdatum = (user_datum_t *) hashtab_search(policydbp->p_users.table,
						   (hashtab_key_t) id);
	if (!usrdatum) {
		usrdatum = (user_datum_t *) malloc(sizeof(user_datum_t));
		if (!usrdatum) {
			yyerror("out of memory");
			free(id);
			return -1;
		}
		memset(usrdatum, 0, sizeof(user_datum_t));
		usrdatum->value = ++policydbp->p_users.nprim;
		ebitmap_init(&usrdatum->roles);
		ret = hashtab_insert(policydbp->p_users.table,
				     (hashtab_key_t) id, (hashtab_datum_t) usrdatum);
		if (ret) {
			yyerror("hash table overflow");
			free(usrdatum);
			free(id);
			return -1;
		}
	} else
		free(id);

	while ((id = queue_remove(id_queue))) {
		if (set_user_roles(&usrdatum->roles, id))
			continue;
	}

	if (mlspol) {
		id = queue_remove(id_queue);
		if (!id) {
			yyerror("no default level specified for user");
			return -1;
		}

		levdatum = (level_datum_t *)
				hashtab_search(policydbp->p_levels.table,
						(hashtab_key_t) id);
		if (!levdatum) {
			sprintf(errormsg, "unknown sensitivity %s used in user"
					" level definition", id);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		free(id);

		usrdatum->dfltlevel.sens = levdatum->level->sens;
		ebitmap_init(&usrdatum->dfltlevel.cat);

		while ((id = queue_remove(id_queue))) {
			if (parse_categories(id, levdatum,
			                     &usrdatum->dfltlevel.cat)) {
				free(id);
				return -1;
			}
			free(id);
		}

		id = queue_remove(id_queue);

		for (l = 0; l < 2; l++) {
			levdatum = (level_datum_t *)
				hashtab_search(policydbp->p_levels.table,
						     (hashtab_key_t) id);
			if (!levdatum) {
				sprintf(errormsg, "unknown sensitivity %s used in user range definition", id);
				yyerror(errormsg);
				free(id);
				return -1;
			}
			free(id);
			usrdatum->range.level[l].sens = levdatum->level->sens;
			ebitmap_init(&usrdatum->range.level[l].cat);

			while ((id = queue_remove(id_queue))) {
				if (parse_categories(id, levdatum,
				              &usrdatum->range.level[l].cat)) {
					free(id);
					return -1;
				}
				free(id);
			}

			id = queue_remove(id_queue);
			if (!id)
				break;
		}

		if (l == 0) {
			usrdatum->range.level[1].sens =
						usrdatum->range.level[0].sens;
			if (ebitmap_cpy(&usrdatum->range.level[1].cat,
			                &usrdatum->range.level[0].cat)) {
				yyerror("out of memory");
				goto out;
			}
		}
		if (!mls_level_dom(&usrdatum->range.level[1],
		                   &usrdatum->range.level[0])) {
			yyerror("high level does not dominate low level");
			goto out;
		}
		if (!mls_level_between(&usrdatum->dfltlevel,
		                       &usrdatum->range.level[0],
		                       &usrdatum->range.level[1])) {
			yyerror("default level not within user range");
			goto out;
		}
	}
	return 0;

out:
	ebitmap_destroy(&usrdatum->dfltlevel.cat);
	ebitmap_destroy(&usrdatum->range.level[0].cat);
	ebitmap_destroy(&usrdatum->range.level[1].cat);
	return -1;
}


static int parse_security_context(context_struct_t * c)
{
	char *id;
	role_datum_t *role;
	type_datum_t *typdatum;
	user_datum_t *usrdatum;
	level_datum_t *levdatum;
	int l;

	if (pass == 1) {
		id = queue_remove(id_queue); free(id); /* user  */
		id = queue_remove(id_queue); free(id); /* role  */
		id = queue_remove(id_queue); free(id); /* type  */
		if (mlspol) {
			id = queue_remove(id_queue); free(id); 
			for (l = 0; l < 2; l++) {
				while ((id = queue_remove(id_queue))) {
					free(id);
				}
				id = queue_remove(id_queue);
				if (!id)
					break;
				free(id); 
			}
		}
		return 0;
	}

	context_init(c);

	/* extract the user */
	id = queue_remove(id_queue);
	if (!id) {
		yyerror("no effective user?");
		goto bad;
	}
	usrdatum = (user_datum_t *) hashtab_search(policydbp->p_users.table,
						   (hashtab_key_t) id);
	if (!usrdatum) {
		sprintf(errormsg, "user %s is not defined", id);
		yyerror(errormsg);
		free(id);
		goto bad;
	}
	c->user = usrdatum->value;

	/* no need to keep the user name */
	free(id);

	/* extract the role */
	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no role name for sid context definition?");
		return -1;
	}
	role = (role_datum_t *) hashtab_search(policydbp->p_roles.table,
					       (hashtab_key_t) id);
	if (!role) {
		sprintf(errormsg, "role %s is not defined", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	c->role = role->value;

	/* no need to keep the role name */
	free(id);


	/* extract the type */
	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no type name for sid context definition?");
		return -1;
	}
	typdatum = (type_datum_t *) hashtab_search(policydbp->p_types.table,
						   (hashtab_key_t) id);
	if (!typdatum || typdatum->isattr) {
		sprintf(errormsg, "type %s is not defined", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	c->type = typdatum->value;

	/* no need to keep the type name */
	free(id);

	if (mlspol) {
		/* extract the low sensitivity */
		id = (char *) queue_head(id_queue);
		if (!id) {
			yyerror("no sensitivity name for sid context"
							" definition?");
			return -1;
		}

		id = (char *) queue_remove(id_queue);
		for (l = 0; l < 2; l++) {
			levdatum = (level_datum_t *)
				hashtab_search(policydbp->p_levels.table,
						     (hashtab_key_t) id);
			if (!levdatum) {
				sprintf(errormsg, "Sensitivity %s is not "
								"defined", id);
				yyerror(errormsg);
				free(id);
				return -1;
			}
			free(id);
			c->range.level[l].sens = levdatum->level->sens;

			/* extract low category set */
			while ((id = queue_remove(id_queue))) {
				if (parse_categories(id, levdatum,
				                     &c->range.level[l].cat)) {
					free(id);
					return -1;
				}
				free(id);
			}

			/* extract high sensitivity */
			id = (char *) queue_remove(id_queue);
			if (!id)
				break;
		}

		if (l == 0) {
			c->range.level[1].sens = c->range.level[0].sens;
			if (ebitmap_cpy(&c->range.level[1].cat,
						&c->range.level[0].cat)) {

				yyerror("out of memory");
				goto bad;
			}
		}
	}

	if (!policydb_context_isvalid(policydbp, c)) {
		yyerror("invalid security context");
		goto bad;
	}
	return 0;

      bad:
	context_destroy(c);

	return -1;
}


static int define_initial_sid_context(void)
{
	char *id;
	ocontext_t *c, *head;

	if (pass == 1) {
		id = (char *) queue_remove(id_queue); free(id);
		parse_security_context(NULL);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no sid name for SID context definition?");
		return -1;
	}
	head = policydbp->ocontexts[OCON_ISID];
	for (c = head; c; c = c->next) {
		if (!strcmp(id, c->u.name))
			break;
	}

	if (!c) {
		sprintf(errormsg, "SID %s is not defined", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	if (c->context[0].user) {
		sprintf(errormsg, "The context for SID %s is multiply defined", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	/* no need to keep the sid name */
	free(id);

	if (parse_security_context(&c->context[0]))
		return -1;

	return 0;
}

static int define_fs_context(unsigned int major, unsigned int minor)
{
	ocontext_t *newc, *c, *head;

	if (pass == 1) {
		parse_security_context(NULL);
		parse_security_context(NULL);
		return 0;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *) malloc(6);
	if (!newc->u.name) {
		yyerror("out of memory");
		free(newc);
		return -1;
	}
	sprintf(newc->u.name, "%02x:%02x", major, minor);

	if (parse_security_context(&newc->context[0])) {
		free(newc->u.name);
		free(newc);
		return -1;
	}
	if (parse_security_context(&newc->context[1])) {
		context_destroy(&newc->context[0]);
		free(newc->u.name);
		free(newc);
		return -1;
	}
	head = policydbp->ocontexts[OCON_FS];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg, "duplicate entry for file system %s", newc->u.name);
			yyerror(errormsg);
			context_destroy(&newc->context[0]);
			context_destroy(&newc->context[1]);
			free(newc->u.name);
			free(newc);
			return -1;
		}
	}

	newc->next = head;
	policydbp->ocontexts[OCON_FS] = newc;

	return 0;
}

static int define_port_context(unsigned int low, unsigned int high)
{
	ocontext_t *newc, *c, *l, *head;
	unsigned int protocol;
	char *id;

	if (pass == 1) {
		id = (char *) queue_remove(id_queue); free(id);
		parse_security_context(NULL);
		return 0;
	}

	newc = malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	id = (char *) queue_remove(id_queue);
	if (!id) {
		free(newc);
		return -1;
	}
	if ((strcmp(id, "tcp") == 0) || (strcmp(id, "TCP") == 0)) {
		protocol = IPPROTO_TCP;
	} else if ((strcmp(id, "udp") == 0) || (strcmp(id, "UDP") == 0)) {
		protocol = IPPROTO_UDP;
	} else {
		sprintf(errormsg, "unrecognized protocol %s", id);
		yyerror(errormsg);
		free(newc);
		return -1;
	}

	newc->u.port.protocol = protocol;
	newc->u.port.low_port = low;
	newc->u.port.high_port = high;

	if (low > high) {
		sprintf(errormsg, "low port %d exceeds high port %d", low, high);
		yyerror(errormsg);
		free(newc);
		return -1;
	}

	if (parse_security_context(&newc->context[0])) {
		free(newc);
		return -1;
	}

	/* Preserve the matching order specified in the configuration. */
	head = policydbp->ocontexts[OCON_PORT];
	for (l = NULL, c = head; c; l = c, c = c->next) {
		unsigned int prot2, low2, high2;

		prot2 = c->u.port.protocol;
		low2 = c->u.port.low_port;
		high2 = c->u.port.high_port;
		if (protocol != prot2)
			continue;
		if (low == low2 && high == high2) {
			sprintf(errormsg, "duplicate portcon entry for %s %d-%d ", id, low, high);
			goto bad;
		}
		if (low2 <= low && high2 >= high) {
			sprintf(errormsg, "portcon entry for %s %d-%d hidden by earlier entry for %d-%d", id, low, high, low2, high2);
			goto bad;
		}
	}

	if (l)
		l->next = newc;
	else
		policydbp->ocontexts[OCON_PORT] = newc;

	return 0;

bad:
	yyerror(errormsg);
	free(newc);
	return -1;
}

static int define_netif_context(void)
{
	ocontext_t *newc, *c, *head;

	if (pass == 1) {
		free(queue_remove(id_queue));
		parse_security_context(NULL);
		parse_security_context(NULL);
		return 0;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *) queue_remove(id_queue);
	if (!newc->u.name) {
		free(newc);
		return -1;
	}
	if (parse_security_context(&newc->context[0])) {
		free(newc->u.name);
		free(newc);
		return -1;
	}
	if (parse_security_context(&newc->context[1])) {
		context_destroy(&newc->context[0]);
		free(newc->u.name);
		free(newc);
		return -1;
	}
	head = policydbp->ocontexts[OCON_NETIF];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg, "duplicate entry for network interface %s", newc->u.name);
			yyerror(errormsg);
			context_destroy(&newc->context[0]);
			context_destroy(&newc->context[1]);
			free(newc->u.name);
			free(newc);
			return -1;
		}
	}

	newc->next = head;
	policydbp->ocontexts[OCON_NETIF] = newc;
	return 0;
}

static int define_ipv4_node_context(unsigned int addr, unsigned int mask)
{
	ocontext_t *newc, *c, *l, *head;

	if (pass == 1) {
		parse_security_context(NULL);
		if (mlspol)
			free(queue_remove(id_queue));
		return 0;
	}

	newc = malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.node.addr = addr;
	newc->u.node.mask = mask;

	if (parse_security_context(&newc->context[0])) {
		free(newc);
		return -1;
	}

 	/* Create order of most specific to least retaining
 	   the order specified in the configuration. */
	head = policydbp->ocontexts[OCON_NODE];
	for (l = NULL, c = head; c; l = c, c = c->next) {
 		if (newc->u.node.mask > c->u.node.mask)
 			break;
 	}

	newc->next = c;

	if (l)
		l->next = newc;
	else
		policydbp->ocontexts[OCON_NODE] = newc;

	return 0;
}

static int define_ipv6_node_context(void)
{
	char *id;
	int rc = 0;
	struct in6_addr addr, mask;
	ocontext_t *newc, *c, *l, *head;
	
	if (pass == 1) {
		free(queue_remove(id_queue));
		free(queue_remove(id_queue));
		parse_security_context(NULL);
		goto out;
	}
	
	id = queue_remove(id_queue);
	if (!id) {
		yyerror("failed to read ipv6 address");
		rc = -1;
		goto out;
	}

	rc = inet_pton(AF_INET6, id, &addr);
	free (id);
	if (rc < 1) {
		yyerror("failed to parse ipv6 address");
		if (rc == 0)
			rc = -1;
		goto out;
	}

	id = queue_remove(id_queue);
	if (!id) {
		yyerror("failed to read ipv6 address");
		rc = -1;
		goto out;
	}

	rc = inet_pton(AF_INET6, id, &mask);
	free(id);
	if (rc < 1) {
		yyerror("failed to parse ipv6 mask");
		if (rc == 0)
			rc = -1;
		goto out;
	}
	
	newc = malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		rc = -1;
		goto out;
	}

	memset(newc, 0, sizeof(ocontext_t));
	memcpy(&newc->u.node6.addr[0], &addr.s6_addr32[0], 16);
	memcpy(&newc->u.node6.mask[0], &mask.s6_addr32[0], 16);

	if (parse_security_context(&newc->context[0])) {
		free(newc);
		rc = -1;
		goto out;
	}

	/* Create order of most specific to least retaining
	   the order specified in the configuration. */
	head = policydbp->ocontexts[OCON_NODE6];
	for (l = NULL, c = head; c; l = c, c = c->next) {
		if (memcmp(&newc->u.node6.mask,&c->u.node6.mask,16) > 0)
			break;
	}

	newc->next = c;

	if (l)
		l->next = newc;
	else
		policydbp->ocontexts[OCON_NODE6] = newc;

	rc = 0;
out:
	return rc;
}

static int define_fs_use(int behavior)
{
	ocontext_t *newc, *c, *head;

	if (pass == 1) {
		free(queue_remove(id_queue));
		parse_security_context(NULL);
		return 0;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *) queue_remove(id_queue);
	if (!newc->u.name) {
		free(newc);
		return -1;
	}
	newc->v.behavior = behavior;
	if (parse_security_context(&newc->context[0])) {
		free(newc->u.name);
		free(newc);
		return -1;
	}

	head = policydbp->ocontexts[OCON_FSUSE];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg, "duplicate fs_use entry for filesystem type %s", newc->u.name);
			yyerror(errormsg);
			context_destroy(&newc->context[0]);
			free(newc->u.name);
			free(newc);
			return -1;
		}
	}

	newc->next = head;
	policydbp->ocontexts[OCON_FSUSE] = newc;
	return 0;
}

static int define_genfs_context_helper(char *fstype, int has_type)
{
	struct genfs *genfs_p, *genfs, *newgenfs;
	ocontext_t *newc, *c, *head, *p;
	char *type = NULL;
	int len, len2;

	if (pass == 1) {
		free(fstype);
		free(queue_remove(id_queue));
		if (has_type)
			free(queue_remove(id_queue));
		parse_security_context(NULL);
		return 0;
	}

	for (genfs_p = NULL, genfs = policydbp->genfs; 
	     genfs; genfs_p = genfs, genfs = genfs->next) {
		if (strcmp(fstype, genfs->fstype) <= 0)
			break;
	}

	if (!genfs || strcmp(fstype, genfs->fstype)) {
		newgenfs = malloc(sizeof(struct genfs));
		if (!newgenfs) {
			yyerror("out of memory");
			return -1;
		}
		memset(newgenfs, 0, sizeof(struct genfs));
		newgenfs->fstype = fstype;
		newgenfs->next = genfs;
		if (genfs_p) 
			genfs_p->next = newgenfs;
		else
			policydbp->genfs = newgenfs;
		genfs = newgenfs;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *) queue_remove(id_queue);
	if (!newc->u.name) 
		goto fail;
	if (has_type) {
		type = (char *) queue_remove(id_queue);
		if (!type) 
			goto fail;
		if (type[1] != 0) {
			sprintf(errormsg, "invalid type %s", type);
			yyerror(errormsg);
			goto fail;
		}
		switch (type[0]) {
		case 'b':
			newc->v.sclass = SECCLASS_BLK_FILE;
			break;
		case 'c':
			newc->v.sclass = SECCLASS_CHR_FILE;
			break;
		case 'd':
			newc->v.sclass = SECCLASS_DIR;
			break;
		case 'p':
			newc->v.sclass = SECCLASS_FIFO_FILE;
			break;
		case 'l':
			newc->v.sclass = SECCLASS_LNK_FILE;
			break;
		case 's':
			newc->v.sclass = SECCLASS_SOCK_FILE;
			break;
		case '-':
			newc->v.sclass = SECCLASS_FILE;
			break;
		default:
			sprintf(errormsg, "invalid type %s", type);
			yyerror(errormsg);
			goto fail;
		}
	}
	if (parse_security_context(&newc->context[0])) 
		goto fail;

	head = genfs->head;

	for (p = NULL, c = head; c; p = c, c = c->next) {
		if (!strcmp(newc->u.name, c->u.name) && 
		    (!newc->v.sclass || !c->v.sclass || newc->v.sclass == c->v.sclass)) {
			sprintf(errormsg, "duplicate entry for genfs entry (%s, %s)", fstype, newc->u.name);
			yyerror(errormsg);
			goto fail;
		}
		len = strlen(newc->u.name);
		len2 = strlen(c->u.name);
		if (len > len2)
			break;
	}

	newc->next = c;
	if (p) 
		p->next = newc;
	else
		genfs->head = newc;
	return 0;
fail:
	if (type)
		free(type);
	context_destroy(&newc->context[0]);
	if (fstype)
		free(fstype);
	if (newc->u.name)
		free(newc->u.name);
	free(newc);
	return -1;
}

static int define_genfs_context(int has_type)
{
	return define_genfs_context_helper(queue_remove(id_queue), has_type);
}

static int define_range_trans(void)
{
	char *id;
	level_datum_t *levdatum = 0;
	mls_range_t range;
	ebitmap_t doms, types, negset;
	range_trans_t *rt = 0;
	unsigned int i, j;
	int l, add = 1;

	if (!mlspol) {
		yyerror("range_transition rule in non-MLS configuration");
		return -1;
	}

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		id = queue_remove(id_queue); free(id); 
		for (l = 0; l < 2; l++) {
			while ((id = queue_remove(id_queue))) {
				free(id);
			}
			id = queue_remove(id_queue);
			if (!id)
				break;
			free(id); 
		}
		return 0;
	}

	ebitmap_init(&doms);
	ebitmap_init(&types);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&doms, &negset, id, &add))
			return -1;
	}
	ebitmap_destroy(&negset);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&types, &negset, id, &add))
			return -1;
	}
	ebitmap_destroy(&negset);

	id = (char *)queue_remove(id_queue);
	if (!id) {
		yyerror("no range in range_transition definition?");
		return -1;
	}
	for (l = 0; l < 2; l++) {
		levdatum = hashtab_search(policydbp->p_levels.table, id);
		if (!levdatum) {
			sprintf(errormsg, "unknown level %s used in range_transition definition", id);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		free(id);
		range.level[l].sens = levdatum->level->sens;

		ebitmap_init(&range.level[l].cat);

		while ((id = queue_remove(id_queue))) {
			if (parse_categories(id, levdatum,
			                     &range.level[l].cat)) {
				free(id);
				return -1;
			}
			free(id);
		}

		id = (char *)queue_remove(id_queue);
		if (!id)
			break;
	}
	if (l == 0) {
		range.level[1].sens = range.level[0].sens;
		if (ebitmap_cpy(&range.level[1].cat, &range.level[0].cat)) {
			yyerror("out of memory");
			return -1;
		}
	}

	if (!mls_level_dom(&range.level[1], &range.level[0])) {
		yyerror("range_transition high level does not dominate low level");
		return -1;
	}

	for (i = ebitmap_startbit(&doms); i < ebitmap_length(&doms); i++) {
		if (!ebitmap_get_bit(&doms, i))
			continue;
		for (j = ebitmap_startbit(&types); j < ebitmap_length(&types); j++) {
			if (!ebitmap_get_bit(&types, j))
				continue;

			for (rt = policydbp->range_tr; rt; rt = rt->next) {
				if (rt->dom == (i + 1) && rt->type == (j + 1)) {
					sprintf(errormsg, "duplicate range_transition defined for (%s,%s)",
					        type_val_to_name(i + 1), type_val_to_name(j + 1));
					yyerror(errormsg);
					return -1;
				}
			}

			rt = malloc(sizeof(range_trans_t));
			if (!rt) {
				yyerror("out of memory");
				return -1;
			}
			memset(rt, 0, sizeof(range_trans_t));
			rt->dom = i + 1;
			rt->type = j + 1;
			rt->range.level[0].sens = range.level[0].sens;
			if (ebitmap_cpy(&rt->range.level[0].cat,
			               &range.level[0].cat)) {
				yyerror("out of memory");
				free(rt);
				return -1;
			}
			rt->range.level[1].sens = range.level[1].sens;
			if (ebitmap_cpy(&rt->range.level[1].cat,
			               &range.level[1].cat)) {
				yyerror("out of memory");
				free(rt);
				return -1;
			}
			rt->next = policydbp->range_tr;
			policydbp->range_tr = rt;
		}
	}

	ebitmap_destroy(&doms);
	ebitmap_destroy(&types);
	ebitmap_destroy(&range.level[0].cat);
	ebitmap_destroy(&range.level[1].cat);
	return 0;
}

/* FLASK */


#line 5202 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 186 "policy_parse.y"
{ if (pass == 1) { if (policydb_index_classes(policydbp)) return -1; } }
break;
case 2:
#line 188 "policy_parse.y"
{ if (pass == 1) { if (policydb_index_bools(policydbp)) return -1;}
			   if (pass == 2) { if (policydb_index_others(policydbp, 1)) return -1;} }
break;
case 6:
#line 196 "policy_parse.y"
{if (define_class()) return -1;}
break;
case 9:
#line 202 "policy_parse.y"
{if (define_initial_sid()) return -1;}
break;
case 15:
#line 213 "policy_parse.y"
{if (define_common_perms()) return -1;}
break;
case 18:
#line 219 "policy_parse.y"
{if (define_av_perms(FALSE)) return -1;}
break;
case 19:
#line 221 "policy_parse.y"
{if (define_av_perms(TRUE)) return -1;}
break;
case 20:
#line 223 "policy_parse.y"
{if (define_av_perms(TRUE)) return -1;}
break;
case 26:
#line 234 "policy_parse.y"
{if (define_sens()) return -1;}
break;
case 27:
#line 236 "policy_parse.y"
{if (define_sens()) return -1;}
break;
case 29:
#line 241 "policy_parse.y"
{if (define_dominance()) return -1;}
break;
case 30:
#line 243 "policy_parse.y"
{if (define_dominance()) return -1;}
break;
case 35:
#line 252 "policy_parse.y"
{if (define_category()) return -1;}
break;
case 36:
#line 254 "policy_parse.y"
{if (define_category()) return -1;}
break;
case 39:
#line 260 "policy_parse.y"
{if (define_level()) return -1;}
break;
case 40:
#line 262 "policy_parse.y"
{if (define_level()) return -1;}
break;
case 45:
#line 271 "policy_parse.y"
{ if (define_constraint((constraint_expr_t*)yyvsp[-1].valptr)) return -1; }
break;
case 46:
#line 274 "policy_parse.y"
{ if (define_validatetrans((constraint_expr_t*)yyvsp[-1].valptr)) return -1; }
break;
case 65:
#line 299 "policy_parse.y"
{ if (define_attrib()) return -1;}
break;
case 66:
#line 302 "policy_parse.y"
{if (define_type(1)) return -1;}
break;
case 67:
#line 304 "policy_parse.y"
{if (define_type(0)) return -1;}
break;
case 68:
#line 307 "policy_parse.y"
{if (define_typealias()) return -1;}
break;
case 69:
#line 310 "policy_parse.y"
{if (define_typeattribute()) return -1;}
break;
case 72:
#line 316 "policy_parse.y"
{if (define_bool()) return -1;}
break;
case 73:
#line 319 "policy_parse.y"
{ if (insert_id("T",0)) return -1; }
break;
case 74:
#line 321 "policy_parse.y"
{ if (insert_id("F",0)) return -1; }
break;
case 75:
#line 324 "policy_parse.y"
{ if (pass == 2) { if (define_conditional((cond_expr_t*)yyvsp[-3].ptr, (cond_av_list_t*)yyvsp[-1].ptr,(cond_av_list_t*) 0) < 0) return -1;  }}
break;
case 76:
#line 326 "policy_parse.y"
{ if (pass == 2) { if (define_conditional((cond_expr_t*)yyvsp[-7].ptr,(cond_av_list_t*)yyvsp[-5].ptr,(cond_av_list_t*)yyvsp[-1].ptr) < 0 ) return -1;  }}
break;
case 77:
#line 328 "policy_parse.y"
{ if (pass == 2) { if (define_conditional((cond_expr_t*)yyvsp[-6].ptr,(cond_av_list_t*)yyvsp[-4].ptr,(cond_av_list_t*) 0) < 0 ) return -1;  }}
break;
case 78:
#line 330 "policy_parse.y"
{ if (pass == 2) { if (define_conditional((cond_expr_t*)yyvsp[-6].ptr,(cond_av_list_t*) 0,(cond_av_list_t*) yyvsp[-1].ptr) < 0 ) return -1;  }}
break;
case 81:
#line 337 "policy_parse.y"
{ yyval.ptr = yyvsp[-1].ptr;}
break;
case 82:
#line 339 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_NOT, yyvsp[0].ptr, 0);
			  if (yyval.ptr == 0) return -1; }
break;
case 83:
#line 342 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_AND, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 84:
#line 345 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_OR, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return   -1; }
break;
case 85:
#line 348 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_XOR, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 86:
#line 351 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_EQ, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 87:
#line 354 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_NEQ, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 88:
#line 357 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 89:
#line 360 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_BOOL,0, 0);
			  if (yyval.ptr == COND_ERR) return   -1; }
break;
case 90:
#line 364 "policy_parse.y"
{ yyval.ptr = define_cond_pol_list((cond_av_list_t *) 0, (cond_av_list_t *)yyvsp[0].ptr);}
break;
case 91:
#line 366 "policy_parse.y"
{ yyval.ptr = define_cond_pol_list((cond_av_list_t *)yyvsp[-1].ptr, (cond_av_list_t *)yyvsp[0].ptr); }
break;
case 92:
#line 369 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 93:
#line 371 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 94:
#line 374 "policy_parse.y"
{ yyval.ptr = define_cond_compute_type(AVTAB_TRANSITION) ;
                          if (yyval.ptr == COND_ERR) return -1;}
break;
case 95:
#line 377 "policy_parse.y"
{ yyval.ptr = define_cond_compute_type(AVTAB_MEMBER) ;
                          if (yyval.ptr ==  COND_ERR) return -1;}
break;
case 96:
#line 380 "policy_parse.y"
{ yyval.ptr = define_cond_compute_type(AVTAB_CHANGE) ;
                          if (yyval.ptr == COND_ERR) return -1;}
break;
case 97:
#line 384 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 98:
#line 386 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 99:
#line 388 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 100:
#line 390 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 101:
#line 393 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(AVTAB_ALLOWED) ;
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 102:
#line 397 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(AVTAB_AUDITALLOW) ;
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 103:
#line 401 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(AVTAB_AUDITDENY) ;
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 104:
#line 405 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(-AVTAB_AUDITDENY);
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 105:
#line 409 "policy_parse.y"
{if (define_compute_type(AVTAB_TRANSITION)) return -1;}
break;
case 106:
#line 411 "policy_parse.y"
{if (define_compute_type(AVTAB_MEMBER)) return -1;}
break;
case 107:
#line 413 "policy_parse.y"
{if (define_compute_type(AVTAB_CHANGE)) return -1;}
break;
case 108:
#line 416 "policy_parse.y"
{ if (define_range_trans()) return -1; }
break;
case 114:
#line 425 "policy_parse.y"
{if (define_te_avtab(AVTAB_ALLOWED)) return -1; }
break;
case 115:
#line 428 "policy_parse.y"
{if (define_te_avtab(AVTAB_AUDITALLOW)) return -1; }
break;
case 116:
#line 431 "policy_parse.y"
{if (define_te_avtab(AVTAB_AUDITDENY)) return -1; }
break;
case 117:
#line 434 "policy_parse.y"
{if (define_te_avtab(-AVTAB_AUDITDENY)) return -1; }
break;
case 118:
#line 437 "policy_parse.y"
{if (define_te_avtab(-AVTAB_ALLOWED)) return -1; }
break;
case 119:
#line 440 "policy_parse.y"
{if (define_role_types()) return -1;}
break;
case 121:
#line 445 "policy_parse.y"
{if (define_role_trans()) return -1; }
break;
case 122:
#line 448 "policy_parse.y"
{if (define_role_allow()) return -1; }
break;
case 123:
#line 451 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 124:
#line 453 "policy_parse.y"
{ yyval.ptr = merge_roles_dom((role_datum_t*)yyvsp[-1].ptr, (role_datum_t*)yyvsp[0].ptr); if (yyval.ptr == 0) return -1;}
break;
case 125:
#line 456 "policy_parse.y"
{yyval.ptr = define_role_dom(NULL); if (yyval.ptr == 0) return -1;}
break;
case 126:
#line 458 "policy_parse.y"
{yyval.ptr = define_role_dom((role_datum_t*)yyvsp[-1].ptr); if (yyval.ptr == 0) return -1;}
break;
case 133:
#line 470 "policy_parse.y"
{ if (define_constraint((constraint_expr_t*)yyvsp[-1].valptr)) return -1; }
break;
case 134:
#line 473 "policy_parse.y"
{ if (define_validatetrans((constraint_expr_t*)yyvsp[-1].valptr)) return -1; }
break;
case 135:
#line 476 "policy_parse.y"
{ yyval.valptr = yyvsp[-1].valptr; }
break;
case 136:
#line 478 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NOT, yyvsp[0].valptr, 0);
			  if (yyval.valptr == 0) return -1; }
break;
case 137:
#line 481 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_AND, yyvsp[-2].valptr, yyvsp[0].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 138:
#line 484 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_OR, yyvsp[-2].valptr, yyvsp[0].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 139:
#line 487 "policy_parse.y"
{ yyval.valptr = yyvsp[0].valptr; }
break;
case 140:
#line 490 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_USER, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 141:
#line 493 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 142:
#line 496 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_TYPE, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 143:
#line 498 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 144:
#line 499 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_USER, yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 145:
#line 501 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 146:
#line 502 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_TARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 147:
#line 504 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 148:
#line 505 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_XTARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 149:
#line 507 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 150:
#line 508 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 151:
#line 510 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 152:
#line 511 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 153:
#line 513 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 154:
#line 514 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_XTARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 155:
#line 516 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 156:
#line 517 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 157:
#line 519 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 158:
#line 520 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 159:
#line 522 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 160:
#line 523 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_XTARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 161:
#line 526 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_USER, CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 162:
#line 528 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 163:
#line 529 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 164:
#line 531 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 165:
#line 532 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 166:
#line 535 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, yyvsp[0].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 167:
#line 537 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 168:
#line 538 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 169:
#line 540 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 170:
#line 541 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 171:
#line 544 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_L1L2, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 172:
#line 547 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_L1H2, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 173:
#line 550 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_H1L2, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 174:
#line 553 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_H1H2, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 175:
#line 556 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_L1H1, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 176:
#line 559 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_L2H2, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 177:
#line 563 "policy_parse.y"
{ yyval.valptr = CEXPR_EQ; }
break;
case 178:
#line 565 "policy_parse.y"
{ yyval.valptr = CEXPR_NEQ; }
break;
case 179:
#line 568 "policy_parse.y"
{ yyval.valptr = yyvsp[0].valptr; }
break;
case 180:
#line 570 "policy_parse.y"
{ yyval.valptr = CEXPR_DOM; }
break;
case 181:
#line 572 "policy_parse.y"
{ yyval.valptr = CEXPR_DOMBY; }
break;
case 182:
#line 574 "policy_parse.y"
{ yyval.valptr = CEXPR_INCOMP; }
break;
case 187:
#line 583 "policy_parse.y"
{if (define_user()) return -1;}
break;
case 192:
#line 592 "policy_parse.y"
{if (define_initial_sid_context()) return -1;}
break;
case 197:
#line 601 "policy_parse.y"
{if (define_fs_context(yyvsp[-3].val,yyvsp[-2].val)) return -1;}
break;
case 203:
#line 612 "policy_parse.y"
{if (define_port_context(yyvsp[-1].val,yyvsp[-1].val)) return -1;}
break;
case 204:
#line 614 "policy_parse.y"
{if (define_port_context(yyvsp[-3].val,yyvsp[-1].val)) return -1;}
break;
case 209:
#line 623 "policy_parse.y"
{if (define_netif_context()) return -1;}
break;
case 214:
#line 632 "policy_parse.y"
{if (define_ipv4_node_context(yyvsp[-2].val,yyvsp[-1].val)) return -1;}
break;
case 215:
#line 634 "policy_parse.y"
{if (define_ipv6_node_context()) return -1;}
break;
case 218:
#line 640 "policy_parse.y"
{if (define_fs_use(SECURITY_FS_USE_XATTR)) return -1;}
break;
case 219:
#line 642 "policy_parse.y"
{if (define_fs_use(SECURITY_FS_USE_TASK)) return -1;}
break;
case 220:
#line 644 "policy_parse.y"
{if (define_fs_use(SECURITY_FS_USE_TRANS)) return -1;}
break;
case 225:
#line 653 "policy_parse.y"
{if (define_genfs_context(1)) return -1;}
break;
case 226:
#line 654 "policy_parse.y"
{insert_id("-", 0);}
break;
case 227:
#line 655 "policy_parse.y"
{if (define_genfs_context(1)) return -1;}
break;
case 228:
#line 657 "policy_parse.y"
{if (define_genfs_context(0)) return -1;}
break;
case 229:
#line 660 "policy_parse.y"
{ 
			  unsigned int addr;
	  		  unsigned char *p = ((unsigned char *)&addr);

			  p[0] = yyvsp[-6].val & 0xff;				
			  p[1] = yyvsp[-4].val & 0xff;
			  p[2] = yyvsp[-2].val & 0xff;
			  p[3] = yyvsp[0].val & 0xff;
			  yyval.val = addr;
			}
break;
case 233:
#line 677 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 234:
#line 679 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 235:
#line 682 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 236:
#line 684 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 241:
#line 694 "policy_parse.y"
{ if (insert_separator(0)) return -1; }
break;
case 242:
#line 696 "policy_parse.y"
{ if (insert_separator(0)) return -1; }
break;
case 243:
#line 698 "policy_parse.y"
{ if (insert_id("*", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
break;
case 244:
#line 701 "policy_parse.y"
{ if (insert_id("~", 0)) return -1;
			  if (insert_separator(0)) return -1; }
break;
case 245:
#line 704 "policy_parse.y"
{ if (insert_id("~", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
break;
case 246:
#line 706 "policy_parse.y"
{ if (insert_id("-", 0)) return -1; }
break;
case 247:
#line 707 "policy_parse.y"
{ if (insert_separator(0)) return -1; }
break;
case 248:
#line 710 "policy_parse.y"
{ if (insert_id("~", 1)) return -1; }
break;
case 249:
#line 713 "policy_parse.y"
{ if (insert_id("*", 1)) return -1; }
break;
case 257:
#line 725 "policy_parse.y"
{ if (insert_id(yytext, 1)) return -1; }
break;
case 264:
#line 734 "policy_parse.y"
{ if (insert_id("-", 0)) return -1; }
break;
case 267:
#line 737 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
case 268:
#line 740 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
case 269:
#line 743 "policy_parse.y"
{ if (insert_id(yytext, 1)) return -1; }
break;
case 279:
#line 757 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
case 280:
#line 760 "policy_parse.y"
{ yyval.val = strtoul(yytext,NULL,0); }
break;
case 281:
#line 763 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
#line 6079 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
